(define (domain npc-jt)
  (:requirements :adl :typing :equality)

  (:types
   MAGIC-LAMP - THING
   GENIE - MONSTER
   KNIGHT - HUMAN
   KING - HUMAN
   MONSTER - CHARACTER
   HUMAN - CHARACTER
   COUNT - OBJECT
   PLACE - OBJECT
   THING - OBJECT
   CHARACTER - OBJECT)

  (:predicates
   (ALIVE ?WHO - CHARACTER)
   (DEAD ?WHO - CHARACTER)
   (AT ?WHO - CHARACTER ?WHERE - PLACE)
   (UNCONFINED ?WHO - CHARACTER)
   (HAS ?WHO - CHARACTER ?WHAT - THING)
   (LOVES ?WHO - HUMAN ?WHO-ELSE - HUMAN)
   (SINGLE ?WHO - HUMAN)
   (MARRIED ?WHO - HUMAN)
   (MARRIED-TO ?WHO - HUMAN ?WHO-ELSE - HUMAN)
   (LOYAL-TO ?KING - KING ?KNIGHT - KNIGHT)
   (BEAUTIFUL ?WHO - HUMAN)
   (SCARY ?WHO - MONSTER)
   (CONTROLS ?WHO - CHARACTER ?GEN - GENIE)
   (IN ?GEN - GENIE ?LAMP - MAGIC-LAMP)
   (JUSTIFIED-CONTROLS-DEAD ?WHO-CONTROLS-1 - CHARACTER ?GEN-CONTROLS-1 - GENIE
    ?INTENDS-WHO - CHARACTER ?WHO-DEAD-2 - CHARACTER)
   (JUSTIFIED-CONTROLS-HAS ?WHO-CONTROLS-1 - CHARACTER ?GEN-CONTROLS-1 - GENIE
    ?INTENDS-WHO - CHARACTER ?WHO-HAS-2 - CHARACTER ?WHAT-HAS-2 - THING)
   (JUSTIFIED-CONTROLS-CONTROLS ?WHO-CONTROLS-1 - CHARACTER ?GEN-CONTROLS-1 -
    GENIE ?INTENDS-WHO - CHARACTER ?WHO-CONTROLS-2 - CHARACTER ?GEN-CONTROLS-2
    - GENIE)
   (JUSTIFIED-LOVES-MARRIED-TO ?WHO-LOVES-1 - HUMAN ?WHO-ELSE-LOVES-1 - HUMAN
    ?INTENDS-WHO - CHARACTER ?WHO-MARRIED-TO-2 - HUMAN ?WHO-ELSE-MARRIED-TO-2 -
    HUMAN)
   (DELEGATED-MARRIED-TO ?DEL-TO-WHO - CHARACTER ?WHO - HUMAN ?WHO-ELSE - HUMAN)
   (DELEGATED-LOVES ?DEL-TO-WHO - CHARACTER ?WHO - HUMAN ?WHO-ELSE - HUMAN)
   (JUSTIFIED-CONTROLS-LOVES ?WHO-CONTROLS-1 - CHARACTER ?GEN-CONTROLS-1 -
    GENIE ?INTENDS-WHO - CHARACTER ?WHO-LOVES-2 - HUMAN ?WHO-ELSE-LOVES-2 -
    HUMAN)
   (JUSTIFIED-CONTROLS-MARRIED-TO ?WHO-CONTROLS-1 - CHARACTER ?GEN-CONTROLS-1 -
    GENIE ?INTENDS-WHO - CHARACTER ?WHO-MARRIED-TO-2 - HUMAN
    ?WHO-ELSE-MARRIED-TO-2 - HUMAN)
   (JUSTIFIED-HAS-AT ?WHO-HAS-1 - CHARACTER ?WHAT-HAS-1 - THING ?INTENDS-WHO -
    CHARACTER ?WHO-AT-2 - CHARACTER ?WHERE-AT-2 - PLACE)
   (JUSTIFIED-HAS-DEAD ?WHO-HAS-1 - CHARACTER ?WHAT-HAS-1 - THING ?INTENDS-WHO
    - CHARACTER ?WHO-DEAD-2 - CHARACTER)
   (DELEGATED-CONTROLS ?DEL-TO-WHO - CHARACTER ?WHO - CHARACTER ?GEN - GENIE)
   (JUSTIFIED-HAS-HAS ?WHO-HAS-1 - CHARACTER ?WHAT-HAS-1 - THING ?INTENDS-WHO -
    CHARACTER ?WHO-HAS-2 - CHARACTER ?WHAT-HAS-2 - THING)
   (JUSTIFIED-HAS-CONTROLS ?WHO-HAS-1 - CHARACTER ?WHAT-HAS-1 - THING
    ?INTENDS-WHO - CHARACTER ?WHO-CONTROLS-2 - CHARACTER ?GEN-CONTROLS-2 -
    GENIE)
   (JUSTIFIED-HAS-LOVES ?WHO-HAS-1 - CHARACTER ?WHAT-HAS-1 - THING ?INTENDS-WHO
    - CHARACTER ?WHO-LOVES-2 - HUMAN ?WHO-ELSE-LOVES-2 - HUMAN)
   (JUSTIFIED-HAS-MARRIED-TO ?WHO-HAS-1 - CHARACTER ?WHAT-HAS-1 - THING
    ?INTENDS-WHO - CHARACTER ?WHO-MARRIED-TO-2 - HUMAN ?WHO-ELSE-MARRIED-TO-2 -
    HUMAN)
   (DELEGATED-HAS ?DEL-TO-WHO - CHARACTER ?WHO - CHARACTER ?WHAT - THING)
   (JUSTIFIED-DEAD-HAS ?WHO-DEAD-1 - CHARACTER ?INTENDS-WHO - CHARACTER
    ?WHO-HAS-2 - CHARACTER ?WHAT-HAS-2 - THING)
   (JUSTIFIED-DEAD-CONTROLS ?WHO-DEAD-1 - CHARACTER ?INTENDS-WHO - CHARACTER
    ?WHO-CONTROLS-2 - CHARACTER ?GEN-CONTROLS-2 - GENIE)
   (JUSTIFIED-DEAD-LOVES ?WHO-DEAD-1 - CHARACTER ?INTENDS-WHO - CHARACTER
    ?WHO-LOVES-2 - HUMAN ?WHO-ELSE-LOVES-2 - HUMAN)
   (JUSTIFIED-DEAD-MARRIED-TO ?WHO-DEAD-1 - CHARACTER ?INTENDS-WHO - CHARACTER
    ?WHO-MARRIED-TO-2 - HUMAN ?WHO-ELSE-MARRIED-TO-2 - HUMAN)
   (DELEGATED-DEAD ?DEL-TO-WHO - CHARACTER ?WHO - CHARACTER)
   (JUSTIFIED-AT-AT ?WHO-AT-1 - CHARACTER ?WHERE-AT-1 - PLACE ?INTENDS-WHO -
    CHARACTER ?WHO-AT-2 - CHARACTER ?WHERE-AT-2 - PLACE)
   (INTENDS-AT ?INTENDS-WHO - CHARACTER ?WHO - CHARACTER ?WHERE - PLACE)
   (JUSTIFIED-AT-DEAD ?WHO-AT-1 - CHARACTER ?WHERE-AT-1 - PLACE ?INTENDS-WHO -
    CHARACTER ?WHO-DEAD-2 - CHARACTER)
   (INTENDS-DEAD ?INTENDS-WHO - CHARACTER ?WHO - CHARACTER)
   (JUSTIFIED-AT-HAS ?WHO-AT-1 - CHARACTER ?WHERE-AT-1 - PLACE ?INTENDS-WHO -
    CHARACTER ?WHO-HAS-2 - CHARACTER ?WHAT-HAS-2 - THING)
   (INTENDS-HAS ?INTENDS-WHO - CHARACTER ?WHO - CHARACTER ?WHAT - THING)
   (JUSTIFIED-AT-CONTROLS ?WHO-AT-1 - CHARACTER ?WHERE-AT-1 - PLACE
    ?INTENDS-WHO - CHARACTER ?WHO-CONTROLS-2 - CHARACTER ?GEN-CONTROLS-2 -
    GENIE)
   (INTENDS-CONTROLS ?INTENDS-WHO - CHARACTER ?WHO - CHARACTER ?GEN - GENIE)
   (JUSTIFIED-AT-LOVES ?WHO-AT-1 - CHARACTER ?WHERE-AT-1 - PLACE ?INTENDS-WHO -
    CHARACTER ?WHO-LOVES-2 - HUMAN ?WHO-ELSE-LOVES-2 - HUMAN)
   (INTENDS-LOVES ?INTENDS-WHO - CHARACTER ?WHO - HUMAN ?WHO-ELSE - HUMAN)
   (JUSTIFIED-AT-MARRIED-TO ?WHO-AT-1 - CHARACTER ?WHERE-AT-1 - PLACE
    ?INTENDS-WHO - CHARACTER ?WHO-MARRIED-TO-2 - HUMAN ?WHO-ELSE-MARRIED-TO-2 -
    HUMAN)
   (DELEGATED-AT ?DEL-TO-WHO - CHARACTER ?WHO - CHARACTER ?WHERE - PLACE)
   (INTENDS-MARRIED-TO ?INTENDS-WHO - CHARACTER ?WHO - HUMAN ?WHO-ELSE - HUMAN))

  (:action TRAVEL-BECAUSE-MARRIED-TO-B-1
    :parameters (?TRAVELLER - CHARACTER ?FROM - PLACE ?DEST - PLACE
                 ?WHO-MARRIED-TO-1 - HUMAN ?WHO-ELSE-MARRIED-TO-1 - HUMAN)
    :precondition (AND
                   (INTENDS-MARRIED-TO ?TRAVELLER ?WHO-MARRIED-TO-1
                    ?WHO-ELSE-MARRIED-TO-1)
                   (FORALL (?C - CHARACTER)
                    (NOT (DELEGATED-AT ?C ?TRAVELLER ?DEST)))
                   (ALIVE ?TRAVELLER)
                   (AT ?TRAVELLER ?FROM)
                   (UNCONFINED ?TRAVELLER)
                   (NOT (= ?FROM ?DEST)))
    :effect (AND
             (NOT
              (JUSTIFIED-AT-MARRIED-TO ?TRAVELLER ?DEST ?TRAVELLER
               ?WHO-MARRIED-TO-1 ?WHO-ELSE-MARRIED-TO-1))
             (JUSTIFIED-AT-MARRIED-TO ?TRAVELLER ?FROM ?TRAVELLER
              ?WHO-MARRIED-TO-1 ?WHO-ELSE-MARRIED-TO-1)
             (NOT (AT ?TRAVELLER ?FROM))
             (AT ?TRAVELLER ?DEST)))

  (:action TRAVEL-BECAUSE-LOVES-B-1
    :parameters (?TRAVELLER - CHARACTER ?FROM - PLACE ?DEST - PLACE
                 ?WHO-LOVES-1 - HUMAN ?WHO-ELSE-LOVES-1 - HUMAN)
    :precondition (AND
                   (INTENDS-LOVES ?TRAVELLER ?WHO-LOVES-1 ?WHO-ELSE-LOVES-1)
                   (FORALL (?C - CHARACTER)
                    (NOT (DELEGATED-AT ?C ?TRAVELLER ?DEST)))
                   (ALIVE ?TRAVELLER)
                   (AT ?TRAVELLER ?FROM)
                   (UNCONFINED ?TRAVELLER)
                   (NOT (= ?FROM ?DEST)))
    :effect (AND
             (NOT
              (JUSTIFIED-AT-LOVES ?TRAVELLER ?DEST ?TRAVELLER ?WHO-LOVES-1
               ?WHO-ELSE-LOVES-1))
             (JUSTIFIED-AT-LOVES ?TRAVELLER ?FROM ?TRAVELLER ?WHO-LOVES-1
              ?WHO-ELSE-LOVES-1)
             (NOT (AT ?TRAVELLER ?FROM))
             (AT ?TRAVELLER ?DEST)))

  (:action TRAVEL-BECAUSE-CONTROLS-B-1
    :parameters (?TRAVELLER - CHARACTER ?FROM - PLACE ?DEST - PLACE
                 ?WHO-CONTROLS-1 - CHARACTER ?GEN-CONTROLS-1 - GENIE)
    :precondition (AND
                   (INTENDS-CONTROLS ?TRAVELLER ?WHO-CONTROLS-1
                    ?GEN-CONTROLS-1)
                   (FORALL (?C - CHARACTER)
                    (NOT (DELEGATED-AT ?C ?TRAVELLER ?DEST)))
                   (ALIVE ?TRAVELLER)
                   (AT ?TRAVELLER ?FROM)
                   (UNCONFINED ?TRAVELLER)
                   (NOT (= ?FROM ?DEST)))
    :effect (AND
             (NOT
              (JUSTIFIED-AT-CONTROLS ?TRAVELLER ?DEST ?TRAVELLER
               ?WHO-CONTROLS-1 ?GEN-CONTROLS-1))
             (JUSTIFIED-AT-CONTROLS ?TRAVELLER ?FROM ?TRAVELLER ?WHO-CONTROLS-1
              ?GEN-CONTROLS-1)
             (NOT (AT ?TRAVELLER ?FROM))
             (AT ?TRAVELLER ?DEST)))

  (:action TRAVEL-BECAUSE-HAS-B-1
    :parameters (?TRAVELLER - CHARACTER ?FROM - PLACE ?DEST - PLACE ?WHO-HAS-1
                 - CHARACTER ?WHAT-HAS-1 - THING)
    :precondition (AND (INTENDS-HAS ?TRAVELLER ?WHO-HAS-1 ?WHAT-HAS-1)
                       (FORALL (?C - CHARACTER)
                        (NOT (DELEGATED-AT ?C ?TRAVELLER ?DEST)))
                       (ALIVE ?TRAVELLER)
                       (AT ?TRAVELLER ?FROM)
                       (UNCONFINED ?TRAVELLER)
                       (NOT (= ?FROM ?DEST)))
    :effect (AND
             (NOT
              (JUSTIFIED-AT-HAS ?TRAVELLER ?DEST ?TRAVELLER ?WHO-HAS-1
               ?WHAT-HAS-1))
             (JUSTIFIED-AT-HAS ?TRAVELLER ?FROM ?TRAVELLER ?WHO-HAS-1
              ?WHAT-HAS-1)
             (NOT (AT ?TRAVELLER ?FROM))
             (AT ?TRAVELLER ?DEST)))

  (:action TRAVEL-BECAUSE-DEAD-B-1
    :parameters (?TRAVELLER - CHARACTER ?FROM - PLACE ?DEST - PLACE ?WHO-DEAD-1
                 - CHARACTER)
    :precondition (AND (INTENDS-DEAD ?TRAVELLER ?WHO-DEAD-1)
                       (FORALL (?C - CHARACTER)
                        (NOT (DELEGATED-AT ?C ?TRAVELLER ?DEST)))
                       (ALIVE ?TRAVELLER)
                       (AT ?TRAVELLER ?FROM)
                       (UNCONFINED ?TRAVELLER)
                       (NOT (= ?FROM ?DEST)))
    :effect (AND
             (NOT (JUSTIFIED-AT-DEAD ?TRAVELLER ?DEST ?TRAVELLER ?WHO-DEAD-1))
             (JUSTIFIED-AT-DEAD ?TRAVELLER ?FROM ?TRAVELLER ?WHO-DEAD-1)
             (NOT (AT ?TRAVELLER ?FROM))
             (AT ?TRAVELLER ?DEST)))

  (:action TRAVEL-BECAUSE-AT-A-1
    :parameters (?TRAVELLER - CHARACTER ?FROM - PLACE ?DEST - PLACE)
    :precondition (AND (INTENDS-AT ?TRAVELLER ?TRAVELLER ?DEST)
                       (FORALL (?C - CHARACTER)
                        (IMPLY (NOT (= ?C ?TRAVELLER))
                         (NOT (DELEGATED-AT ?C ?TRAVELLER ?DEST))))
                       (ALIVE ?TRAVELLER)
                       (AT ?TRAVELLER ?FROM)
                       (UNCONFINED ?TRAVELLER)
                       (NOT (= ?FROM ?DEST)))
    :effect (AND (JUSTIFIED-AT-AT ?TRAVELLER ?FROM ?TRAVELLER ?TRAVELLER ?DEST)
                 (NOT (DELEGATED-AT ?TRAVELLER ?TRAVELLER ?DEST))
                 (NOT (AT ?TRAVELLER ?FROM))
                 (AT ?TRAVELLER ?DEST)))

  (:action SLAY-BECAUSE-MARRIED-TO-B-1
    :parameters (?SLAYER - KNIGHT ?SLAYEE - MONSTER ?WHERE - PLACE
                 ?WHO-MARRIED-TO-1 - HUMAN ?WHO-ELSE-MARRIED-TO-1 - HUMAN)
    :precondition (AND
                   (INTENDS-MARRIED-TO ?SLAYER ?WHO-MARRIED-TO-1
                    ?WHO-ELSE-MARRIED-TO-1)
                   (FORALL (?C - CHARACTER) (NOT (DELEGATED-DEAD ?C ?SLAYEE)))
                   (AT ?SLAYER ?WHERE)
                   (AT ?SLAYEE ?WHERE)
                   (ALIVE ?SLAYER)
                   (ALIVE ?SLAYEE))
    :effect (AND
             (NOT
              (JUSTIFIED-DEAD-MARRIED-TO ?SLAYEE ?SLAYER ?WHO-MARRIED-TO-1
               ?WHO-ELSE-MARRIED-TO-1))
             (JUSTIFIED-AT-MARRIED-TO ?SLAYER ?WHERE ?SLAYER ?WHO-MARRIED-TO-1
              ?WHO-ELSE-MARRIED-TO-1)
             (JUSTIFIED-AT-MARRIED-TO ?SLAYEE ?WHERE ?SLAYER ?WHO-MARRIED-TO-1
              ?WHO-ELSE-MARRIED-TO-1)
             (NOT (ALIVE ?SLAYEE))
             (DEAD ?SLAYEE)))

  (:action SLAY-BECAUSE-LOVES-B-1
    :parameters (?SLAYER - KNIGHT ?SLAYEE - MONSTER ?WHERE - PLACE ?WHO-LOVES-1
                 - HUMAN ?WHO-ELSE-LOVES-1 - HUMAN)
    :precondition (AND (INTENDS-LOVES ?SLAYER ?WHO-LOVES-1 ?WHO-ELSE-LOVES-1)
                       (FORALL (?C - CHARACTER)
                        (NOT (DELEGATED-DEAD ?C ?SLAYEE)))
                       (AT ?SLAYER ?WHERE)
                       (AT ?SLAYEE ?WHERE)
                       (ALIVE ?SLAYER)
                       (ALIVE ?SLAYEE))
    :effect (AND
             (NOT
              (JUSTIFIED-DEAD-LOVES ?SLAYEE ?SLAYER ?WHO-LOVES-1
               ?WHO-ELSE-LOVES-1))
             (JUSTIFIED-AT-LOVES ?SLAYER ?WHERE ?SLAYER ?WHO-LOVES-1
              ?WHO-ELSE-LOVES-1)
             (JUSTIFIED-AT-LOVES ?SLAYEE ?WHERE ?SLAYER ?WHO-LOVES-1
              ?WHO-ELSE-LOVES-1)
             (NOT (ALIVE ?SLAYEE))
             (DEAD ?SLAYEE)))

  (:action SLAY-BECAUSE-CONTROLS-B-1
    :parameters (?SLAYER - KNIGHT ?SLAYEE - MONSTER ?WHERE - PLACE
                 ?WHO-CONTROLS-1 - CHARACTER ?GEN-CONTROLS-1 - GENIE)
    :precondition (AND
                   (INTENDS-CONTROLS ?SLAYER ?WHO-CONTROLS-1 ?GEN-CONTROLS-1)
                   (FORALL (?C - CHARACTER) (NOT (DELEGATED-DEAD ?C ?SLAYEE)))
                   (AT ?SLAYER ?WHERE)
                   (AT ?SLAYEE ?WHERE)
                   (ALIVE ?SLAYER)
                   (ALIVE ?SLAYEE))
    :effect (AND
             (NOT
              (JUSTIFIED-DEAD-CONTROLS ?SLAYEE ?SLAYER ?WHO-CONTROLS-1
               ?GEN-CONTROLS-1))
             (JUSTIFIED-AT-CONTROLS ?SLAYER ?WHERE ?SLAYER ?WHO-CONTROLS-1
              ?GEN-CONTROLS-1)
             (JUSTIFIED-AT-CONTROLS ?SLAYEE ?WHERE ?SLAYER ?WHO-CONTROLS-1
              ?GEN-CONTROLS-1)
             (NOT (ALIVE ?SLAYEE))
             (DEAD ?SLAYEE)))

  (:action SLAY-BECAUSE-HAS-B-1
    :parameters (?SLAYER - KNIGHT ?SLAYEE - MONSTER ?WHERE - PLACE ?WHO-HAS-1 -
                 CHARACTER ?WHAT-HAS-1 - THING)
    :precondition (AND (INTENDS-HAS ?SLAYER ?WHO-HAS-1 ?WHAT-HAS-1)
                       (FORALL (?C - CHARACTER)
                        (NOT (DELEGATED-DEAD ?C ?SLAYEE)))
                       (AT ?SLAYER ?WHERE)
                       (AT ?SLAYEE ?WHERE)
                       (ALIVE ?SLAYER)
                       (ALIVE ?SLAYEE))
    :effect (AND
             (NOT (JUSTIFIED-DEAD-HAS ?SLAYEE ?SLAYER ?WHO-HAS-1 ?WHAT-HAS-1))
             (JUSTIFIED-AT-HAS ?SLAYER ?WHERE ?SLAYER ?WHO-HAS-1 ?WHAT-HAS-1)
             (JUSTIFIED-AT-HAS ?SLAYEE ?WHERE ?SLAYER ?WHO-HAS-1 ?WHAT-HAS-1)
             (NOT (ALIVE ?SLAYEE))
             (DEAD ?SLAYEE)))

  (:action SLAY-BECAUSE-DEAD-A-1
    :parameters (?SLAYER - KNIGHT ?SLAYEE - MONSTER ?WHERE - PLACE)
    :precondition (AND (INTENDS-DEAD ?SLAYER ?SLAYEE)
                       (FORALL (?C - CHARACTER)
                        (IMPLY (NOT (= ?C ?SLAYER))
                         (NOT (DELEGATED-DEAD ?C ?SLAYEE))))
                       (AT ?SLAYER ?WHERE)
                       (AT ?SLAYEE ?WHERE)
                       (ALIVE ?SLAYER)
                       (ALIVE ?SLAYEE))
    :effect (AND (JUSTIFIED-AT-DEAD ?SLAYER ?WHERE ?SLAYER ?SLAYEE)
                 (JUSTIFIED-AT-DEAD ?SLAYEE ?WHERE ?SLAYER ?SLAYEE)
                 (NOT (DELEGATED-DEAD ?SLAYER ?SLAYEE))
                 (NOT (ALIVE ?SLAYEE))
                 (DEAD ?SLAYEE)))

  (:action PILLAGE-BECAUSE-MARRIED-TO-B-1
    :parameters (?PILLAGER - CHARACTER ?BODY - CHARACTER ?WHAT - THING ?WHERE -
                 PLACE ?WHO-MARRIED-TO-1 - HUMAN ?WHO-ELSE-MARRIED-TO-1 - HUMAN)
    :precondition (AND
                   (INTENDS-MARRIED-TO ?PILLAGER ?WHO-MARRIED-TO-1
                    ?WHO-ELSE-MARRIED-TO-1)
                   (FORALL (?C - CHARACTER)
                    (NOT (DELEGATED-HAS ?C ?PILLAGER ?WHAT)))
                   (AT ?PILLAGER ?WHERE)
                   (AT ?BODY ?WHERE)
                   (ALIVE ?PILLAGER)
                   (DEAD ?BODY)
                   (HAS ?BODY ?WHAT))
    :effect (AND
             (NOT
              (JUSTIFIED-HAS-MARRIED-TO ?PILLAGER ?WHAT ?PILLAGER
               ?WHO-MARRIED-TO-1 ?WHO-ELSE-MARRIED-TO-1))
             (JUSTIFIED-AT-MARRIED-TO ?PILLAGER ?WHERE ?PILLAGER
              ?WHO-MARRIED-TO-1 ?WHO-ELSE-MARRIED-TO-1)
             (JUSTIFIED-AT-MARRIED-TO ?BODY ?WHERE ?PILLAGER ?WHO-MARRIED-TO-1
              ?WHO-ELSE-MARRIED-TO-1)
             (JUSTIFIED-DEAD-MARRIED-TO ?BODY ?PILLAGER ?WHO-MARRIED-TO-1
              ?WHO-ELSE-MARRIED-TO-1)
             (JUSTIFIED-HAS-MARRIED-TO ?BODY ?WHAT ?PILLAGER ?WHO-MARRIED-TO-1
              ?WHO-ELSE-MARRIED-TO-1)
             (NOT (HAS ?BODY ?WHAT))
             (HAS ?PILLAGER ?WHAT)))

  (:action PILLAGE-BECAUSE-LOVES-B-1
    :parameters (?PILLAGER - CHARACTER ?BODY - CHARACTER ?WHAT - THING ?WHERE -
                 PLACE ?WHO-LOVES-1 - HUMAN ?WHO-ELSE-LOVES-1 - HUMAN)
    :precondition (AND (INTENDS-LOVES ?PILLAGER ?WHO-LOVES-1 ?WHO-ELSE-LOVES-1)
                       (FORALL (?C - CHARACTER)
                        (NOT (DELEGATED-HAS ?C ?PILLAGER ?WHAT)))
                       (AT ?PILLAGER ?WHERE)
                       (AT ?BODY ?WHERE)
                       (ALIVE ?PILLAGER)
                       (DEAD ?BODY)
                       (HAS ?BODY ?WHAT))
    :effect (AND
             (NOT
              (JUSTIFIED-HAS-LOVES ?PILLAGER ?WHAT ?PILLAGER ?WHO-LOVES-1
               ?WHO-ELSE-LOVES-1))
             (JUSTIFIED-AT-LOVES ?PILLAGER ?WHERE ?PILLAGER ?WHO-LOVES-1
              ?WHO-ELSE-LOVES-1)
             (JUSTIFIED-AT-LOVES ?BODY ?WHERE ?PILLAGER ?WHO-LOVES-1
              ?WHO-ELSE-LOVES-1)
             (JUSTIFIED-DEAD-LOVES ?BODY ?PILLAGER ?WHO-LOVES-1
              ?WHO-ELSE-LOVES-1)
             (JUSTIFIED-HAS-LOVES ?BODY ?WHAT ?PILLAGER ?WHO-LOVES-1
              ?WHO-ELSE-LOVES-1)
             (NOT (HAS ?BODY ?WHAT))
             (HAS ?PILLAGER ?WHAT)))

  (:action PILLAGE-BECAUSE-CONTROLS-B-1
    :parameters (?PILLAGER - CHARACTER ?BODY - CHARACTER ?WHAT - THING ?WHERE -
                 PLACE ?WHO-CONTROLS-1 - CHARACTER ?GEN-CONTROLS-1 - GENIE)
    :precondition (AND
                   (INTENDS-CONTROLS ?PILLAGER ?WHO-CONTROLS-1 ?GEN-CONTROLS-1)
                   (FORALL (?C - CHARACTER)
                    (NOT (DELEGATED-HAS ?C ?PILLAGER ?WHAT)))
                   (AT ?PILLAGER ?WHERE)
                   (AT ?BODY ?WHERE)
                   (ALIVE ?PILLAGER)
                   (DEAD ?BODY)
                   (HAS ?BODY ?WHAT))
    :effect (AND
             (NOT
              (JUSTIFIED-HAS-CONTROLS ?PILLAGER ?WHAT ?PILLAGER ?WHO-CONTROLS-1
               ?GEN-CONTROLS-1))
             (JUSTIFIED-AT-CONTROLS ?PILLAGER ?WHERE ?PILLAGER ?WHO-CONTROLS-1
              ?GEN-CONTROLS-1)
             (JUSTIFIED-AT-CONTROLS ?BODY ?WHERE ?PILLAGER ?WHO-CONTROLS-1
              ?GEN-CONTROLS-1)
             (JUSTIFIED-DEAD-CONTROLS ?BODY ?PILLAGER ?WHO-CONTROLS-1
              ?GEN-CONTROLS-1)
             (JUSTIFIED-HAS-CONTROLS ?BODY ?WHAT ?PILLAGER ?WHO-CONTROLS-1
              ?GEN-CONTROLS-1)
             (NOT (HAS ?BODY ?WHAT))
             (HAS ?PILLAGER ?WHAT)))

  (:action PILLAGE-BECAUSE-HAS-A-1
    :parameters (?PILLAGER - CHARACTER ?BODY - CHARACTER ?WHAT - THING ?WHERE -
                 PLACE)
    :precondition (AND (INTENDS-HAS ?PILLAGER ?PILLAGER ?WHAT)
                       (FORALL (?C - CHARACTER)
                        (IMPLY (NOT (= ?C ?PILLAGER))
                         (NOT (DELEGATED-HAS ?C ?PILLAGER ?WHAT))))
                       (AT ?PILLAGER ?WHERE)
                       (AT ?BODY ?WHERE)
                       (ALIVE ?PILLAGER)
                       (DEAD ?BODY)
                       (HAS ?BODY ?WHAT))
    :effect (AND (JUSTIFIED-AT-HAS ?PILLAGER ?WHERE ?PILLAGER ?PILLAGER ?WHAT)
                 (JUSTIFIED-AT-HAS ?BODY ?WHERE ?PILLAGER ?PILLAGER ?WHAT)
                 (JUSTIFIED-DEAD-HAS ?BODY ?PILLAGER ?PILLAGER ?WHAT)
                 (JUSTIFIED-HAS-HAS ?BODY ?WHAT ?PILLAGER ?PILLAGER ?WHAT)
                 (NOT (DELEGATED-HAS ?PILLAGER ?PILLAGER ?WHAT))
                 (NOT (HAS ?BODY ?WHAT))
                 (HAS ?PILLAGER ?WHAT)))

  (:action PILLAGE-BECAUSE-HAS-B-1
    :parameters (?PILLAGER - CHARACTER ?BODY - CHARACTER ?WHAT - THING ?WHERE -
                 PLACE ?WHO-HAS-1 - CHARACTER ?WHAT-HAS-1 - THING)
    :precondition (AND (INTENDS-HAS ?PILLAGER ?WHO-HAS-1 ?WHAT-HAS-1)
                       (FORALL (?C - CHARACTER)
                        (NOT (DELEGATED-HAS ?C ?PILLAGER ?WHAT)))
                       (AT ?PILLAGER ?WHERE)
                       (AT ?BODY ?WHERE)
                       (ALIVE ?PILLAGER)
                       (DEAD ?BODY)
                       (HAS ?BODY ?WHAT))
    :effect (AND
             (NOT
              (JUSTIFIED-HAS-HAS ?PILLAGER ?WHAT ?PILLAGER ?WHO-HAS-1
               ?WHAT-HAS-1))
             (JUSTIFIED-AT-HAS ?PILLAGER ?WHERE ?PILLAGER ?WHO-HAS-1
              ?WHAT-HAS-1)
             (JUSTIFIED-AT-HAS ?BODY ?WHERE ?PILLAGER ?WHO-HAS-1 ?WHAT-HAS-1)
             (JUSTIFIED-DEAD-HAS ?BODY ?PILLAGER ?WHO-HAS-1 ?WHAT-HAS-1)
             (JUSTIFIED-HAS-HAS ?BODY ?WHAT ?PILLAGER ?WHO-HAS-1 ?WHAT-HAS-1)
             (NOT (HAS ?BODY ?WHAT))
             (HAS ?PILLAGER ?WHAT)))

  (:action GIVE-BECAUSE-MARRIED-TO-B-1
    :parameters (?GIVER - CHARACTER ?GIVEE - CHARACTER ?WHAT - THING ?WHERE -
                 PLACE ?WHO-MARRIED-TO-1 - HUMAN ?WHO-ELSE-MARRIED-TO-1 - HUMAN)
    :precondition (AND
                   (INTENDS-MARRIED-TO ?GIVER ?WHO-MARRIED-TO-1
                    ?WHO-ELSE-MARRIED-TO-1)
                   (FORALL (?C - CHARACTER)
                    (NOT (DELEGATED-HAS ?C ?GIVEE ?WHAT)))
                   (AT ?GIVER ?WHERE)
                   (AT ?GIVEE ?WHERE)
                   (ALIVE ?GIVER)
                   (ALIVE ?GIVEE)
                   (HAS ?GIVER ?WHAT)
                   (NOT (= ?GIVER ?GIVEE)))
    :effect (AND
             (NOT
              (JUSTIFIED-HAS-MARRIED-TO ?GIVEE ?WHAT ?GIVER ?WHO-MARRIED-TO-1
               ?WHO-ELSE-MARRIED-TO-1))
             (JUSTIFIED-AT-MARRIED-TO ?GIVER ?WHERE ?GIVER ?WHO-MARRIED-TO-1
              ?WHO-ELSE-MARRIED-TO-1)
             (JUSTIFIED-AT-MARRIED-TO ?GIVEE ?WHERE ?GIVER ?WHO-MARRIED-TO-1
              ?WHO-ELSE-MARRIED-TO-1)
             (JUSTIFIED-HAS-MARRIED-TO ?GIVER ?WHAT ?GIVER ?WHO-MARRIED-TO-1
              ?WHO-ELSE-MARRIED-TO-1)
             (NOT (HAS ?GIVER ?WHAT))
             (HAS ?GIVEE ?WHAT)))

  (:action GIVE-BECAUSE-LOVES-B-1
    :parameters (?GIVER - CHARACTER ?GIVEE - CHARACTER ?WHAT - THING ?WHERE -
                 PLACE ?WHO-LOVES-1 - HUMAN ?WHO-ELSE-LOVES-1 - HUMAN)
    :precondition (AND (INTENDS-LOVES ?GIVER ?WHO-LOVES-1 ?WHO-ELSE-LOVES-1)
                       (FORALL (?C - CHARACTER)
                        (NOT (DELEGATED-HAS ?C ?GIVEE ?WHAT)))
                       (AT ?GIVER ?WHERE)
                       (AT ?GIVEE ?WHERE)
                       (ALIVE ?GIVER)
                       (ALIVE ?GIVEE)
                       (HAS ?GIVER ?WHAT)
                       (NOT (= ?GIVER ?GIVEE)))
    :effect (AND
             (NOT
              (JUSTIFIED-HAS-LOVES ?GIVEE ?WHAT ?GIVER ?WHO-LOVES-1
               ?WHO-ELSE-LOVES-1))
             (JUSTIFIED-AT-LOVES ?GIVER ?WHERE ?GIVER ?WHO-LOVES-1
              ?WHO-ELSE-LOVES-1)
             (JUSTIFIED-AT-LOVES ?GIVEE ?WHERE ?GIVER ?WHO-LOVES-1
              ?WHO-ELSE-LOVES-1)
             (JUSTIFIED-HAS-LOVES ?GIVER ?WHAT ?GIVER ?WHO-LOVES-1
              ?WHO-ELSE-LOVES-1)
             (NOT (HAS ?GIVER ?WHAT))
             (HAS ?GIVEE ?WHAT)))

  (:action GIVE-BECAUSE-CONTROLS-B-1
    :parameters (?GIVER - CHARACTER ?GIVEE - CHARACTER ?WHAT - THING ?WHERE -
                 PLACE ?WHO-CONTROLS-1 - CHARACTER ?GEN-CONTROLS-1 - GENIE)
    :precondition (AND
                   (INTENDS-CONTROLS ?GIVER ?WHO-CONTROLS-1 ?GEN-CONTROLS-1)
                   (FORALL (?C - CHARACTER)
                    (NOT (DELEGATED-HAS ?C ?GIVEE ?WHAT)))
                   (AT ?GIVER ?WHERE)
                   (AT ?GIVEE ?WHERE)
                   (ALIVE ?GIVER)
                   (ALIVE ?GIVEE)
                   (HAS ?GIVER ?WHAT)
                   (NOT (= ?GIVER ?GIVEE)))
    :effect (AND
             (NOT
              (JUSTIFIED-HAS-CONTROLS ?GIVEE ?WHAT ?GIVER ?WHO-CONTROLS-1
               ?GEN-CONTROLS-1))
             (JUSTIFIED-AT-CONTROLS ?GIVER ?WHERE ?GIVER ?WHO-CONTROLS-1
              ?GEN-CONTROLS-1)
             (JUSTIFIED-AT-CONTROLS ?GIVEE ?WHERE ?GIVER ?WHO-CONTROLS-1
              ?GEN-CONTROLS-1)
             (JUSTIFIED-HAS-CONTROLS ?GIVER ?WHAT ?GIVER ?WHO-CONTROLS-1
              ?GEN-CONTROLS-1)
             (NOT (HAS ?GIVER ?WHAT))
             (HAS ?GIVEE ?WHAT)))

  (:action GIVE-BECAUSE-HAS-A-1
    :parameters (?GIVER - CHARACTER ?GIVEE - CHARACTER ?WHAT - THING ?WHERE -
                 PLACE)
    :precondition (AND (INTENDS-HAS ?GIVER ?GIVEE ?WHAT)
                       (FORALL (?C - CHARACTER)
                        (IMPLY (NOT (= ?C ?GIVER))
                         (NOT (DELEGATED-HAS ?C ?GIVEE ?WHAT))))
                       (AT ?GIVER ?WHERE)
                       (AT ?GIVEE ?WHERE)
                       (ALIVE ?GIVER)
                       (ALIVE ?GIVEE)
                       (HAS ?GIVER ?WHAT)
                       (NOT (= ?GIVER ?GIVEE)))
    :effect (AND (JUSTIFIED-AT-HAS ?GIVER ?WHERE ?GIVER ?GIVEE ?WHAT)
                 (JUSTIFIED-AT-HAS ?GIVEE ?WHERE ?GIVER ?GIVEE ?WHAT)
                 (JUSTIFIED-HAS-HAS ?GIVER ?WHAT ?GIVER ?GIVEE ?WHAT)
                 (NOT (DELEGATED-HAS ?GIVER ?GIVEE ?WHAT))
                 (NOT (HAS ?GIVER ?WHAT))
                 (HAS ?GIVEE ?WHAT)))

  (:action GIVE-BECAUSE-HAS-B-1
    :parameters (?GIVER - CHARACTER ?GIVEE - CHARACTER ?WHAT - THING ?WHERE -
                 PLACE ?WHO-HAS-1 - CHARACTER ?WHAT-HAS-1 - THING)
    :precondition (AND (INTENDS-HAS ?GIVER ?WHO-HAS-1 ?WHAT-HAS-1)
                       (FORALL (?C - CHARACTER)
                        (NOT (DELEGATED-HAS ?C ?GIVEE ?WHAT)))
                       (AT ?GIVER ?WHERE)
                       (AT ?GIVEE ?WHERE)
                       (ALIVE ?GIVER)
                       (ALIVE ?GIVEE)
                       (HAS ?GIVER ?WHAT)
                       (NOT (= ?GIVER ?GIVEE)))
    :effect (AND
             (NOT
              (JUSTIFIED-HAS-HAS ?GIVEE ?WHAT ?GIVER ?WHO-HAS-1 ?WHAT-HAS-1))
             (JUSTIFIED-AT-HAS ?GIVER ?WHERE ?GIVER ?WHO-HAS-1 ?WHAT-HAS-1)
             (JUSTIFIED-AT-HAS ?GIVEE ?WHERE ?GIVER ?WHO-HAS-1 ?WHAT-HAS-1)
             (JUSTIFIED-HAS-HAS ?GIVER ?WHAT ?GIVER ?WHO-HAS-1 ?WHAT-HAS-1)
             (NOT (HAS ?GIVER ?WHAT))
             (HAS ?GIVEE ?WHAT)))

  (:action SUMMON-BECAUSE-MARRIED-TO-B-1
    :parameters (?WHO - CHARACTER ?GEN - GENIE ?LAMP - MAGIC-LAMP ?WHERE -
                 PLACE ?WHO-MARRIED-TO-1 - HUMAN ?WHO-ELSE-MARRIED-TO-1 - HUMAN)
    :precondition (AND
                   (INTENDS-MARRIED-TO ?WHO ?WHO-MARRIED-TO-1
                    ?WHO-ELSE-MARRIED-TO-1)
                   (FORALL (?C - CHARACTER)
                    (NOT (DELEGATED-AT ?C ?GEN ?WHERE)))
                   (FORALL (?C - CHARACTER)
                    (NOT (DELEGATED-CONTROLS ?C ?WHO ?GEN)))
                   (AT ?WHO ?WHERE)
                   (HAS ?WHO ?LAMP)
                   (ALIVE ?WHO)
                   (IN ?GEN ?LAMP)
                   (ALIVE ?GEN)
                   (NOT (= ?WHO ?GEN)))
    :effect (AND
             (NOT
              (JUSTIFIED-AT-MARRIED-TO ?GEN ?WHERE ?WHO ?WHO-MARRIED-TO-1
               ?WHO-ELSE-MARRIED-TO-1))
             (JUSTIFIED-AT-MARRIED-TO ?WHO ?WHERE ?WHO ?WHO-MARRIED-TO-1
              ?WHO-ELSE-MARRIED-TO-1)
             (JUSTIFIED-HAS-MARRIED-TO ?WHO ?LAMP ?WHO ?WHO-MARRIED-TO-1
              ?WHO-ELSE-MARRIED-TO-1)
             (NOT (IN ?GEN ?LAMP))
             (AT ?GEN ?WHERE)
             (UNCONFINED ?GEN)
             (CONTROLS ?WHO ?GEN)))

  (:action SUMMON-BECAUSE-LOVES-B-1
    :parameters (?WHO - CHARACTER ?GEN - GENIE ?LAMP - MAGIC-LAMP ?WHERE -
                 PLACE ?WHO-LOVES-1 - HUMAN ?WHO-ELSE-LOVES-1 - HUMAN)
    :precondition (AND (INTENDS-LOVES ?WHO ?WHO-LOVES-1 ?WHO-ELSE-LOVES-1)
                       (FORALL (?C - CHARACTER)
                        (NOT (DELEGATED-AT ?C ?GEN ?WHERE)))
                       (FORALL (?C - CHARACTER)
                        (NOT (DELEGATED-CONTROLS ?C ?WHO ?GEN)))
                       (AT ?WHO ?WHERE)
                       (HAS ?WHO ?LAMP)
                       (ALIVE ?WHO)
                       (IN ?GEN ?LAMP)
                       (ALIVE ?GEN)
                       (NOT (= ?WHO ?GEN)))
    :effect (AND
             (NOT
              (JUSTIFIED-AT-LOVES ?GEN ?WHERE ?WHO ?WHO-LOVES-1
               ?WHO-ELSE-LOVES-1))
             (JUSTIFIED-AT-LOVES ?WHO ?WHERE ?WHO ?WHO-LOVES-1
              ?WHO-ELSE-LOVES-1)
             (JUSTIFIED-HAS-LOVES ?WHO ?LAMP ?WHO ?WHO-LOVES-1
              ?WHO-ELSE-LOVES-1)
             (NOT (IN ?GEN ?LAMP))
             (AT ?GEN ?WHERE)
             (UNCONFINED ?GEN)
             (CONTROLS ?WHO ?GEN)))

  (:action SUMMON-BECAUSE-CONTROLS-B-1
    :parameters (?WHO - CHARACTER ?GEN - GENIE ?LAMP - MAGIC-LAMP ?WHERE -
                 PLACE ?WHO-CONTROLS-1 - CHARACTER ?GEN-CONTROLS-1 - GENIE)
    :precondition (AND (INTENDS-CONTROLS ?WHO ?WHO-CONTROLS-1 ?GEN-CONTROLS-1)
                       (FORALL (?C - CHARACTER)
                        (NOT (DELEGATED-AT ?C ?GEN ?WHERE)))
                       (FORALL (?C - CHARACTER)
                        (NOT (DELEGATED-CONTROLS ?C ?WHO ?GEN)))
                       (AT ?WHO ?WHERE)
                       (HAS ?WHO ?LAMP)
                       (ALIVE ?WHO)
                       (IN ?GEN ?LAMP)
                       (ALIVE ?GEN)
                       (NOT (= ?WHO ?GEN)))
    :effect (AND
             (NOT
              (JUSTIFIED-AT-CONTROLS ?GEN ?WHERE ?WHO ?WHO-CONTROLS-1
               ?GEN-CONTROLS-1))
             (JUSTIFIED-AT-CONTROLS ?WHO ?WHERE ?WHO ?WHO-CONTROLS-1
              ?GEN-CONTROLS-1)
             (JUSTIFIED-HAS-CONTROLS ?WHO ?LAMP ?WHO ?WHO-CONTROLS-1
              ?GEN-CONTROLS-1)
             (NOT (IN ?GEN ?LAMP))
             (AT ?GEN ?WHERE)
             (UNCONFINED ?GEN)
             (CONTROLS ?WHO ?GEN)))

  (:action SUMMON-BECAUSE-HAS-B-1
    :parameters (?WHO - CHARACTER ?GEN - GENIE ?LAMP - MAGIC-LAMP ?WHERE -
                 PLACE ?WHO-HAS-1 - CHARACTER ?WHAT-HAS-1 - THING)
    :precondition (AND (INTENDS-HAS ?WHO ?WHO-HAS-1 ?WHAT-HAS-1)
                       (FORALL (?C - CHARACTER)
                        (NOT (DELEGATED-AT ?C ?GEN ?WHERE)))
                       (FORALL (?C - CHARACTER)
                        (NOT (DELEGATED-CONTROLS ?C ?WHO ?GEN)))
                       (AT ?WHO ?WHERE)
                       (HAS ?WHO ?LAMP)
                       (ALIVE ?WHO)
                       (IN ?GEN ?LAMP)
                       (ALIVE ?GEN)
                       (NOT (= ?WHO ?GEN)))
    :effect (AND
             (NOT (JUSTIFIED-AT-HAS ?GEN ?WHERE ?WHO ?WHO-HAS-1 ?WHAT-HAS-1))
             (JUSTIFIED-AT-HAS ?WHO ?WHERE ?WHO ?WHO-HAS-1 ?WHAT-HAS-1)
             (JUSTIFIED-HAS-HAS ?WHO ?LAMP ?WHO ?WHO-HAS-1 ?WHAT-HAS-1)
             (NOT (IN ?GEN ?LAMP))
             (AT ?GEN ?WHERE)
             (UNCONFINED ?GEN)
             (CONTROLS ?WHO ?GEN)))

  (:action SUMMON-BECAUSE-DEAD-B-1
    :parameters (?WHO - CHARACTER ?GEN - GENIE ?LAMP - MAGIC-LAMP ?WHERE -
                 PLACE ?WHO-DEAD-1 - CHARACTER)
    :precondition (AND (INTENDS-DEAD ?WHO ?WHO-DEAD-1)
                       (FORALL (?C - CHARACTER)
                        (NOT (DELEGATED-AT ?C ?GEN ?WHERE)))
                       (FORALL (?C - CHARACTER)
                        (NOT (DELEGATED-CONTROLS ?C ?WHO ?GEN)))
                       (AT ?WHO ?WHERE)
                       (HAS ?WHO ?LAMP)
                       (ALIVE ?WHO)
                       (IN ?GEN ?LAMP)
                       (ALIVE ?GEN)
                       (NOT (= ?WHO ?GEN)))
    :effect (AND (NOT (JUSTIFIED-AT-DEAD ?GEN ?WHERE ?WHO ?WHO-DEAD-1))
                 (JUSTIFIED-AT-DEAD ?WHO ?WHERE ?WHO ?WHO-DEAD-1)
                 (JUSTIFIED-HAS-DEAD ?WHO ?LAMP ?WHO ?WHO-DEAD-1)
                 (NOT (IN ?GEN ?LAMP))
                 (AT ?GEN ?WHERE)
                 (UNCONFINED ?GEN)
                 (CONTROLS ?WHO ?GEN)))

  (:action SUMMON-BECAUSE-AT-A-1
    :parameters (?WHO - CHARACTER ?GEN - GENIE ?LAMP - MAGIC-LAMP ?WHERE -
                 PLACE)
    :precondition (AND (INTENDS-AT ?WHO ?GEN ?WHERE)
                       (FORALL (?C - CHARACTER)
                        (IMPLY (NOT (= ?C ?WHO))
                         (NOT (DELEGATED-AT ?C ?GEN ?WHERE))))
                       (FORALL (?C - CHARACTER)
                        (NOT (DELEGATED-CONTROLS ?C ?WHO ?GEN)))
                       (AT ?WHO ?WHERE)
                       (HAS ?WHO ?LAMP)
                       (ALIVE ?WHO)
                       (IN ?GEN ?LAMP)
                       (ALIVE ?GEN)
                       (NOT (= ?WHO ?GEN)))
    :effect (AND (JUSTIFIED-AT-AT ?WHO ?WHERE ?WHO ?GEN ?WHERE)
                 (JUSTIFIED-HAS-AT ?WHO ?LAMP ?WHO ?GEN ?WHERE)
                 (NOT (DELEGATED-AT ?WHO ?GEN ?WHERE))
                 (NOT (IN ?GEN ?LAMP))
                 (AT ?GEN ?WHERE)
                 (UNCONFINED ?GEN)
                 (CONTROLS ?WHO ?GEN)))

  (:action SUMMON-BECAUSE-MARRIED-TO-B-3
    :parameters (?WHO - CHARACTER ?GEN - GENIE ?LAMP - MAGIC-LAMP ?WHERE -
                 PLACE ?WHO-MARRIED-TO-1 - HUMAN ?WHO-ELSE-MARRIED-TO-1 - HUMAN)
    :precondition (AND
                   (INTENDS-MARRIED-TO ?WHO ?WHO-MARRIED-TO-1
                    ?WHO-ELSE-MARRIED-TO-1)
                   (FORALL (?C - CHARACTER)
                    (NOT (DELEGATED-AT ?C ?GEN ?WHERE)))
                   (FORALL (?C - CHARACTER)
                    (NOT (DELEGATED-CONTROLS ?C ?WHO ?GEN)))
                   (AT ?WHO ?WHERE)
                   (HAS ?WHO ?LAMP)
                   (ALIVE ?WHO)
                   (IN ?GEN ?LAMP)
                   (ALIVE ?GEN)
                   (NOT (= ?WHO ?GEN)))
    :effect (AND
             (NOT
              (JUSTIFIED-CONTROLS-MARRIED-TO ?WHO ?GEN ?WHO ?WHO-MARRIED-TO-1
               ?WHO-ELSE-MARRIED-TO-1))
             (JUSTIFIED-AT-MARRIED-TO ?WHO ?WHERE ?WHO ?WHO-MARRIED-TO-1
              ?WHO-ELSE-MARRIED-TO-1)
             (JUSTIFIED-HAS-MARRIED-TO ?WHO ?LAMP ?WHO ?WHO-MARRIED-TO-1
              ?WHO-ELSE-MARRIED-TO-1)
             (NOT (IN ?GEN ?LAMP))
             (AT ?GEN ?WHERE)
             (UNCONFINED ?GEN)
             (CONTROLS ?WHO ?GEN)))

  (:action SUMMON-BECAUSE-LOVES-B-3
    :parameters (?WHO - CHARACTER ?GEN - GENIE ?LAMP - MAGIC-LAMP ?WHERE -
                 PLACE ?WHO-LOVES-1 - HUMAN ?WHO-ELSE-LOVES-1 - HUMAN)
    :precondition (AND (INTENDS-LOVES ?WHO ?WHO-LOVES-1 ?WHO-ELSE-LOVES-1)
                       (FORALL (?C - CHARACTER)
                        (NOT (DELEGATED-AT ?C ?GEN ?WHERE)))
                       (FORALL (?C - CHARACTER)
                        (NOT (DELEGATED-CONTROLS ?C ?WHO ?GEN)))
                       (AT ?WHO ?WHERE)
                       (HAS ?WHO ?LAMP)
                       (ALIVE ?WHO)
                       (IN ?GEN ?LAMP)
                       (ALIVE ?GEN)
                       (NOT (= ?WHO ?GEN)))
    :effect (AND
             (NOT
              (JUSTIFIED-CONTROLS-LOVES ?WHO ?GEN ?WHO ?WHO-LOVES-1
               ?WHO-ELSE-LOVES-1))
             (JUSTIFIED-AT-LOVES ?WHO ?WHERE ?WHO ?WHO-LOVES-1
              ?WHO-ELSE-LOVES-1)
             (JUSTIFIED-HAS-LOVES ?WHO ?LAMP ?WHO ?WHO-LOVES-1
              ?WHO-ELSE-LOVES-1)
             (NOT (IN ?GEN ?LAMP))
             (AT ?GEN ?WHERE)
             (UNCONFINED ?GEN)
             (CONTROLS ?WHO ?GEN)))

  (:action SUMMON-BECAUSE-CONTROLS-A-3
    :parameters (?WHO - CHARACTER ?GEN - GENIE ?LAMP - MAGIC-LAMP ?WHERE -
                 PLACE)
    :precondition (AND (INTENDS-CONTROLS ?WHO ?WHO ?GEN)
                       (FORALL (?C - CHARACTER)
                        (NOT (DELEGATED-AT ?C ?GEN ?WHERE)))
                       (FORALL (?C - CHARACTER)
                        (IMPLY (NOT (= ?C ?WHO))
                         (NOT (DELEGATED-CONTROLS ?C ?WHO ?GEN))))
                       (AT ?WHO ?WHERE)
                       (HAS ?WHO ?LAMP)
                       (ALIVE ?WHO)
                       (IN ?GEN ?LAMP)
                       (ALIVE ?GEN)
                       (NOT (= ?WHO ?GEN)))
    :effect (AND (JUSTIFIED-AT-CONTROLS ?WHO ?WHERE ?WHO ?WHO ?GEN)
                 (JUSTIFIED-HAS-CONTROLS ?WHO ?LAMP ?WHO ?WHO ?GEN)
                 (NOT (DELEGATED-CONTROLS ?WHO ?WHO ?GEN))
                 (NOT (IN ?GEN ?LAMP))
                 (AT ?GEN ?WHERE)
                 (UNCONFINED ?GEN)
                 (CONTROLS ?WHO ?GEN)))

  (:action LOVE-SPELL-BECAUSE-MARRIED-TO-B-1
    :parameters (?GEN - GENIE ?TARGET - HUMAN ?LOVER - HUMAN ?WHO-MARRIED-TO-1
                 - HUMAN ?WHO-ELSE-MARRIED-TO-1 - HUMAN)
    :precondition (AND
                   (INTENDS-MARRIED-TO ?GEN ?WHO-MARRIED-TO-1
                    ?WHO-ELSE-MARRIED-TO-1)
                   (FORALL (?C - CHARACTER)
                    (NOT (DELEGATED-LOVES ?C ?TARGET ?LOVER)))
                   (FORALL (?C - CHARACTER)
                    (NOT (DELEGATED-MARRIED-TO ?C ?TARGET ?LOVER)))
                   (UNCONFINED ?GEN)
                   (ALIVE ?GEN)
                   (ALIVE ?TARGET)
                   (ALIVE ?LOVER)
                   (NOT (= ?GEN ?TARGET))
                   (NOT (= ?GEN ?LOVER))
                   (NOT (= ?TARGET ?LOVER)))
    :effect (AND
             (NOT
              (JUSTIFIED-LOVES-MARRIED-TO ?TARGET ?LOVER ?GEN ?WHO-MARRIED-TO-1
               ?WHO-ELSE-MARRIED-TO-1))
             (LOVES ?TARGET ?LOVER)
             (INTENDS-MARRIED-TO ?TARGET ?TARGET ?LOVER)))

  (:action LOVE-SPELL-BECAUSE-LOVES-A-1
    :parameters (?GEN - GENIE ?TARGET - HUMAN ?LOVER - HUMAN)
    :precondition (AND (INTENDS-LOVES ?GEN ?TARGET ?LOVER)
                       (FORALL (?C - CHARACTER)
                        (IMPLY (NOT (= ?C ?GEN))
                         (NOT (DELEGATED-LOVES ?C ?TARGET ?LOVER))))
                       (FORALL (?C - CHARACTER)
                        (NOT (DELEGATED-MARRIED-TO ?C ?TARGET ?LOVER)))
                       (UNCONFINED ?GEN)
                       (ALIVE ?GEN)
                       (ALIVE ?TARGET)
                       (ALIVE ?LOVER)
                       (NOT (= ?GEN ?TARGET))
                       (NOT (= ?GEN ?LOVER))
                       (NOT (= ?TARGET ?LOVER)))
    :effect (AND (NOT (DELEGATED-LOVES ?GEN ?TARGET ?LOVER))
                 (LOVES ?TARGET ?LOVER)
                 (INTENDS-MARRIED-TO ?TARGET ?TARGET ?LOVER)))

  (:action MARRY-BECAUSE-MARRIED-TO-A-3-BECAUSE-MARRIED-TO-A-3
    :parameters (?GROOM - HUMAN ?BRIDE - HUMAN ?WHERE - PLACE)
    :precondition (AND (INTENDS-MARRIED-TO ?BRIDE ?GROOM ?BRIDE)
                       (FORALL (?C - CHARACTER)
                        (IMPLY (NOT (= ?C ?BRIDE))
                         (NOT (DELEGATED-MARRIED-TO ?C ?GROOM ?BRIDE))))
                       (FORALL (?C - CHARACTER)
                        (NOT (DELEGATED-MARRIED-TO ?C ?BRIDE ?GROOM)))
                       (INTENDS-MARRIED-TO ?GROOM ?GROOM ?BRIDE)
                       (FORALL (?C - CHARACTER)
                        (IMPLY (NOT (= ?C ?GROOM))
                         (NOT (DELEGATED-MARRIED-TO ?C ?GROOM ?BRIDE))))
                       (FORALL (?C - CHARACTER)
                        (NOT (DELEGATED-MARRIED-TO ?C ?BRIDE ?GROOM)))
                       (AT ?GROOM ?WHERE)
                       (AT ?BRIDE ?WHERE)
                       (ALIVE ?GROOM)
                       (ALIVE ?BRIDE)
                       (LOVES ?GROOM ?BRIDE)
                       (LOVES ?BRIDE ?GROOM)
                       (SINGLE ?GROOM)
                       (SINGLE ?BRIDE))
    :effect (AND (JUSTIFIED-AT-MARRIED-TO ?GROOM ?WHERE ?BRIDE ?GROOM ?BRIDE)
                 (JUSTIFIED-AT-MARRIED-TO ?BRIDE ?WHERE ?BRIDE ?GROOM ?BRIDE)
                 (JUSTIFIED-LOVES-MARRIED-TO ?GROOM ?BRIDE ?BRIDE ?GROOM
                  ?BRIDE)
                 (JUSTIFIED-LOVES-MARRIED-TO ?BRIDE ?GROOM ?BRIDE ?GROOM
                  ?BRIDE)
                 (NOT (DELEGATED-MARRIED-TO ?BRIDE ?GROOM ?BRIDE))
                 (JUSTIFIED-AT-MARRIED-TO ?GROOM ?WHERE ?GROOM ?GROOM ?BRIDE)
                 (JUSTIFIED-AT-MARRIED-TO ?BRIDE ?WHERE ?GROOM ?GROOM ?BRIDE)
                 (JUSTIFIED-LOVES-MARRIED-TO ?GROOM ?BRIDE ?GROOM ?GROOM
                  ?BRIDE)
                 (JUSTIFIED-LOVES-MARRIED-TO ?BRIDE ?GROOM ?GROOM ?GROOM
                  ?BRIDE)
                 (NOT (DELEGATED-MARRIED-TO ?GROOM ?GROOM ?BRIDE))
                 (NOT (SINGLE ?GROOM))
                 (MARRIED ?GROOM)
                 (NOT (SINGLE ?BRIDE))
                 (MARRIED ?BRIDE)
                 (MARRIED-TO ?GROOM ?BRIDE)
                 (MARRIED-TO ?BRIDE ?GROOM)))

  (:action MARRY-BECAUSE-MARRIED-TO-A-3-BECAUSE-MARRIED-TO-A-4
    :parameters (?GROOM - HUMAN ?BRIDE - HUMAN ?WHERE - PLACE)
    :precondition (AND (INTENDS-MARRIED-TO ?BRIDE ?BRIDE ?GROOM)
                       (FORALL (?C - CHARACTER)
                        (NOT (DELEGATED-MARRIED-TO ?C ?GROOM ?BRIDE)))
                       (FORALL (?C - CHARACTER)
                        (IMPLY (NOT (= ?C ?BRIDE))
                         (NOT (DELEGATED-MARRIED-TO ?C ?BRIDE ?GROOM))))
                       (INTENDS-MARRIED-TO ?GROOM ?GROOM ?BRIDE)
                       (FORALL (?C - CHARACTER)
                        (IMPLY (NOT (= ?C ?GROOM))
                         (NOT (DELEGATED-MARRIED-TO ?C ?GROOM ?BRIDE))))
                       (FORALL (?C - CHARACTER)
                        (NOT (DELEGATED-MARRIED-TO ?C ?BRIDE ?GROOM)))
                       (AT ?GROOM ?WHERE)
                       (AT ?BRIDE ?WHERE)
                       (ALIVE ?GROOM)
                       (ALIVE ?BRIDE)
                       (LOVES ?GROOM ?BRIDE)
                       (LOVES ?BRIDE ?GROOM)
                       (SINGLE ?GROOM)
                       (SINGLE ?BRIDE))
    :effect (AND (JUSTIFIED-AT-MARRIED-TO ?GROOM ?WHERE ?BRIDE ?BRIDE ?GROOM)
                 (JUSTIFIED-AT-MARRIED-TO ?BRIDE ?WHERE ?BRIDE ?BRIDE ?GROOM)
                 (JUSTIFIED-LOVES-MARRIED-TO ?GROOM ?BRIDE ?BRIDE ?BRIDE
                  ?GROOM)
                 (JUSTIFIED-LOVES-MARRIED-TO ?BRIDE ?GROOM ?BRIDE ?BRIDE
                  ?GROOM)
                 (NOT (DELEGATED-MARRIED-TO ?BRIDE ?BRIDE ?GROOM))
                 (JUSTIFIED-AT-MARRIED-TO ?GROOM ?WHERE ?GROOM ?GROOM ?BRIDE)
                 (JUSTIFIED-AT-MARRIED-TO ?BRIDE ?WHERE ?GROOM ?GROOM ?BRIDE)
                 (JUSTIFIED-LOVES-MARRIED-TO ?GROOM ?BRIDE ?GROOM ?GROOM
                  ?BRIDE)
                 (JUSTIFIED-LOVES-MARRIED-TO ?BRIDE ?GROOM ?GROOM ?GROOM
                  ?BRIDE)
                 (NOT (DELEGATED-MARRIED-TO ?GROOM ?GROOM ?BRIDE))
                 (NOT (SINGLE ?GROOM))
                 (MARRIED ?GROOM)
                 (NOT (SINGLE ?BRIDE))
                 (MARRIED ?BRIDE)
                 (MARRIED-TO ?GROOM ?BRIDE)
                 (MARRIED-TO ?BRIDE ?GROOM)))

  (:action MARRY-BECAUSE-MARRIED-TO-A-4-BECAUSE-MARRIED-TO-A-3
    :parameters (?GROOM - HUMAN ?BRIDE - HUMAN ?WHERE - PLACE)
    :precondition (AND (INTENDS-MARRIED-TO ?BRIDE ?GROOM ?BRIDE)
                       (FORALL (?C - CHARACTER)
                        (IMPLY (NOT (= ?C ?BRIDE))
                         (NOT (DELEGATED-MARRIED-TO ?C ?GROOM ?BRIDE))))
                       (FORALL (?C - CHARACTER)
                        (NOT (DELEGATED-MARRIED-TO ?C ?BRIDE ?GROOM)))
                       (INTENDS-MARRIED-TO ?GROOM ?BRIDE ?GROOM)
                       (FORALL (?C - CHARACTER)
                        (NOT (DELEGATED-MARRIED-TO ?C ?GROOM ?BRIDE)))
                       (FORALL (?C - CHARACTER)
                        (IMPLY (NOT (= ?C ?GROOM))
                         (NOT (DELEGATED-MARRIED-TO ?C ?BRIDE ?GROOM))))
                       (AT ?GROOM ?WHERE)
                       (AT ?BRIDE ?WHERE)
                       (ALIVE ?GROOM)
                       (ALIVE ?BRIDE)
                       (LOVES ?GROOM ?BRIDE)
                       (LOVES ?BRIDE ?GROOM)
                       (SINGLE ?GROOM)
                       (SINGLE ?BRIDE))
    :effect (AND (JUSTIFIED-AT-MARRIED-TO ?GROOM ?WHERE ?BRIDE ?GROOM ?BRIDE)
                 (JUSTIFIED-AT-MARRIED-TO ?BRIDE ?WHERE ?BRIDE ?GROOM ?BRIDE)
                 (JUSTIFIED-LOVES-MARRIED-TO ?GROOM ?BRIDE ?BRIDE ?GROOM
                  ?BRIDE)
                 (JUSTIFIED-LOVES-MARRIED-TO ?BRIDE ?GROOM ?BRIDE ?GROOM
                  ?BRIDE)
                 (NOT (DELEGATED-MARRIED-TO ?BRIDE ?GROOM ?BRIDE))
                 (JUSTIFIED-AT-MARRIED-TO ?GROOM ?WHERE ?GROOM ?BRIDE ?GROOM)
                 (JUSTIFIED-AT-MARRIED-TO ?BRIDE ?WHERE ?GROOM ?BRIDE ?GROOM)
                 (JUSTIFIED-LOVES-MARRIED-TO ?GROOM ?BRIDE ?GROOM ?BRIDE
                  ?GROOM)
                 (JUSTIFIED-LOVES-MARRIED-TO ?BRIDE ?GROOM ?GROOM ?BRIDE
                  ?GROOM)
                 (NOT (DELEGATED-MARRIED-TO ?GROOM ?BRIDE ?GROOM))
                 (NOT (SINGLE ?GROOM))
                 (MARRIED ?GROOM)
                 (NOT (SINGLE ?BRIDE))
                 (MARRIED ?BRIDE)
                 (MARRIED-TO ?GROOM ?BRIDE)
                 (MARRIED-TO ?BRIDE ?GROOM)))

  (:action MARRY-BECAUSE-MARRIED-TO-A-4-BECAUSE-MARRIED-TO-A-4
    :parameters (?GROOM - HUMAN ?BRIDE - HUMAN ?WHERE - PLACE)
    :precondition (AND (INTENDS-MARRIED-TO ?BRIDE ?BRIDE ?GROOM)
                       (FORALL (?C - CHARACTER)
                        (NOT (DELEGATED-MARRIED-TO ?C ?GROOM ?BRIDE)))
                       (FORALL (?C - CHARACTER)
                        (IMPLY (NOT (= ?C ?BRIDE))
                         (NOT (DELEGATED-MARRIED-TO ?C ?BRIDE ?GROOM))))
                       (INTENDS-MARRIED-TO ?GROOM ?BRIDE ?GROOM)
                       (FORALL (?C - CHARACTER)
                        (NOT (DELEGATED-MARRIED-TO ?C ?GROOM ?BRIDE)))
                       (FORALL (?C - CHARACTER)
                        (IMPLY (NOT (= ?C ?GROOM))
                         (NOT (DELEGATED-MARRIED-TO ?C ?BRIDE ?GROOM))))
                       (AT ?GROOM ?WHERE)
                       (AT ?BRIDE ?WHERE)
                       (ALIVE ?GROOM)
                       (ALIVE ?BRIDE)
                       (LOVES ?GROOM ?BRIDE)
                       (LOVES ?BRIDE ?GROOM)
                       (SINGLE ?GROOM)
                       (SINGLE ?BRIDE))
    :effect (AND (JUSTIFIED-AT-MARRIED-TO ?GROOM ?WHERE ?BRIDE ?BRIDE ?GROOM)
                 (JUSTIFIED-AT-MARRIED-TO ?BRIDE ?WHERE ?BRIDE ?BRIDE ?GROOM)
                 (JUSTIFIED-LOVES-MARRIED-TO ?GROOM ?BRIDE ?BRIDE ?BRIDE
                  ?GROOM)
                 (JUSTIFIED-LOVES-MARRIED-TO ?BRIDE ?GROOM ?BRIDE ?BRIDE
                  ?GROOM)
                 (NOT (DELEGATED-MARRIED-TO ?BRIDE ?BRIDE ?GROOM))
                 (JUSTIFIED-AT-MARRIED-TO ?GROOM ?WHERE ?GROOM ?BRIDE ?GROOM)
                 (JUSTIFIED-AT-MARRIED-TO ?BRIDE ?WHERE ?GROOM ?BRIDE ?GROOM)
                 (JUSTIFIED-LOVES-MARRIED-TO ?GROOM ?BRIDE ?GROOM ?BRIDE
                  ?GROOM)
                 (JUSTIFIED-LOVES-MARRIED-TO ?BRIDE ?GROOM ?GROOM ?BRIDE
                  ?GROOM)
                 (NOT (DELEGATED-MARRIED-TO ?GROOM ?BRIDE ?GROOM))
                 (NOT (SINGLE ?GROOM))
                 (MARRIED ?GROOM)
                 (NOT (SINGLE ?BRIDE))
                 (MARRIED ?BRIDE)
                 (MARRIED-TO ?GROOM ?BRIDE)
                 (MARRIED-TO ?BRIDE ?GROOM)))

  (:action ORDER-AT-BECAUSE-MARRIED-TO-B-1
    :parameters (?KING - KING ?KNIGHT - KNIGHT ?WHERE - PLACE ?WHO-AT -
                 CHARACTER ?WHERE-AT - PLACE ?WHO-MARRIED-TO-1 - HUMAN
                 ?WHO-ELSE-MARRIED-TO-1 - HUMAN)
    :precondition (AND
                   (INTENDS-MARRIED-TO ?KING ?WHO-MARRIED-TO-1
                    ?WHO-ELSE-MARRIED-TO-1)
                   (FORALL (?C - CHARACTER)
                    (NOT (DELEGATED-AT ?C ?WHO-AT ?WHERE-AT)))
                   (AT ?KING ?WHERE)
                   (AT ?KNIGHT ?WHERE)
                   (ALIVE ?KING)
                   (ALIVE ?KNIGHT)
                   (LOYAL-TO ?KING ?KNIGHT))
    :effect (AND
             (NOT
              (JUSTIFIED-AT-MARRIED-TO ?WHO-AT ?WHERE-AT ?KING
               ?WHO-MARRIED-TO-1 ?WHO-ELSE-MARRIED-TO-1))
             (JUSTIFIED-AT-MARRIED-TO ?KING ?WHERE ?KING ?WHO-MARRIED-TO-1
              ?WHO-ELSE-MARRIED-TO-1)
             (JUSTIFIED-AT-MARRIED-TO ?KNIGHT ?WHERE ?KING ?WHO-MARRIED-TO-1
              ?WHO-ELSE-MARRIED-TO-1)
             (DELEGATED-AT ?KNIGHT ?WHO-AT ?WHERE-AT)
             (NOT (DELEGATED-AT ?KING ?WHO-AT ?WHERE-AT))
             (INTENDS-AT ?KNIGHT ?WHO-AT ?WHERE-AT)))

  (:action ORDER-AT-BECAUSE-LOVES-B-1
    :parameters (?KING - KING ?KNIGHT - KNIGHT ?WHERE - PLACE ?WHO-AT -
                 CHARACTER ?WHERE-AT - PLACE ?WHO-LOVES-1 - HUMAN
                 ?WHO-ELSE-LOVES-1 - HUMAN)
    :precondition (AND (INTENDS-LOVES ?KING ?WHO-LOVES-1 ?WHO-ELSE-LOVES-1)
                       (FORALL (?C - CHARACTER)
                        (NOT (DELEGATED-AT ?C ?WHO-AT ?WHERE-AT)))
                       (AT ?KING ?WHERE)
                       (AT ?KNIGHT ?WHERE)
                       (ALIVE ?KING)
                       (ALIVE ?KNIGHT)
                       (LOYAL-TO ?KING ?KNIGHT))
    :effect (AND
             (NOT
              (JUSTIFIED-AT-LOVES ?WHO-AT ?WHERE-AT ?KING ?WHO-LOVES-1
               ?WHO-ELSE-LOVES-1))
             (JUSTIFIED-AT-LOVES ?KING ?WHERE ?KING ?WHO-LOVES-1
              ?WHO-ELSE-LOVES-1)
             (JUSTIFIED-AT-LOVES ?KNIGHT ?WHERE ?KING ?WHO-LOVES-1
              ?WHO-ELSE-LOVES-1)
             (DELEGATED-AT ?KNIGHT ?WHO-AT ?WHERE-AT)
             (NOT (DELEGATED-AT ?KING ?WHO-AT ?WHERE-AT))
             (INTENDS-AT ?KNIGHT ?WHO-AT ?WHERE-AT)))

  (:action ORDER-AT-BECAUSE-CONTROLS-B-1
    :parameters (?KING - KING ?KNIGHT - KNIGHT ?WHERE - PLACE ?WHO-AT -
                 CHARACTER ?WHERE-AT - PLACE ?WHO-CONTROLS-1 - CHARACTER
                 ?GEN-CONTROLS-1 - GENIE)
    :precondition (AND (INTENDS-CONTROLS ?KING ?WHO-CONTROLS-1 ?GEN-CONTROLS-1)
                       (FORALL (?C - CHARACTER)
                        (NOT (DELEGATED-AT ?C ?WHO-AT ?WHERE-AT)))
                       (AT ?KING ?WHERE)
                       (AT ?KNIGHT ?WHERE)
                       (ALIVE ?KING)
                       (ALIVE ?KNIGHT)
                       (LOYAL-TO ?KING ?KNIGHT))
    :effect (AND
             (NOT
              (JUSTIFIED-AT-CONTROLS ?WHO-AT ?WHERE-AT ?KING ?WHO-CONTROLS-1
               ?GEN-CONTROLS-1))
             (JUSTIFIED-AT-CONTROLS ?KING ?WHERE ?KING ?WHO-CONTROLS-1
              ?GEN-CONTROLS-1)
             (JUSTIFIED-AT-CONTROLS ?KNIGHT ?WHERE ?KING ?WHO-CONTROLS-1
              ?GEN-CONTROLS-1)
             (DELEGATED-AT ?KNIGHT ?WHO-AT ?WHERE-AT)
             (NOT (DELEGATED-AT ?KING ?WHO-AT ?WHERE-AT))
             (INTENDS-AT ?KNIGHT ?WHO-AT ?WHERE-AT)))

  (:action ORDER-AT-BECAUSE-HAS-B-1
    :parameters (?KING - KING ?KNIGHT - KNIGHT ?WHERE - PLACE ?WHO-AT -
                 CHARACTER ?WHERE-AT - PLACE ?WHO-HAS-1 - CHARACTER ?WHAT-HAS-1
                 - THING)
    :precondition (AND (INTENDS-HAS ?KING ?WHO-HAS-1 ?WHAT-HAS-1)
                       (FORALL (?C - CHARACTER)
                        (NOT (DELEGATED-AT ?C ?WHO-AT ?WHERE-AT)))
                       (AT ?KING ?WHERE)
                       (AT ?KNIGHT ?WHERE)
                       (ALIVE ?KING)
                       (ALIVE ?KNIGHT)
                       (LOYAL-TO ?KING ?KNIGHT))
    :effect (AND
             (NOT
              (JUSTIFIED-AT-HAS ?WHO-AT ?WHERE-AT ?KING ?WHO-HAS-1
               ?WHAT-HAS-1))
             (JUSTIFIED-AT-HAS ?KING ?WHERE ?KING ?WHO-HAS-1 ?WHAT-HAS-1)
             (JUSTIFIED-AT-HAS ?KNIGHT ?WHERE ?KING ?WHO-HAS-1 ?WHAT-HAS-1)
             (DELEGATED-AT ?KNIGHT ?WHO-AT ?WHERE-AT)
             (NOT (DELEGATED-AT ?KING ?WHO-AT ?WHERE-AT))
             (INTENDS-AT ?KNIGHT ?WHO-AT ?WHERE-AT)))

  (:action ORDER-AT-BECAUSE-DEAD-B-1
    :parameters (?KING - KING ?KNIGHT - KNIGHT ?WHERE - PLACE ?WHO-AT -
                 CHARACTER ?WHERE-AT - PLACE ?WHO-DEAD-1 - CHARACTER)
    :precondition (AND (INTENDS-DEAD ?KING ?WHO-DEAD-1)
                       (FORALL (?C - CHARACTER)
                        (NOT (DELEGATED-AT ?C ?WHO-AT ?WHERE-AT)))
                       (AT ?KING ?WHERE)
                       (AT ?KNIGHT ?WHERE)
                       (ALIVE ?KING)
                       (ALIVE ?KNIGHT)
                       (LOYAL-TO ?KING ?KNIGHT))
    :effect (AND (NOT (JUSTIFIED-AT-DEAD ?WHO-AT ?WHERE-AT ?KING ?WHO-DEAD-1))
                 (JUSTIFIED-AT-DEAD ?KING ?WHERE ?KING ?WHO-DEAD-1)
                 (JUSTIFIED-AT-DEAD ?KNIGHT ?WHERE ?KING ?WHO-DEAD-1)
                 (DELEGATED-AT ?KNIGHT ?WHO-AT ?WHERE-AT)
                 (NOT (DELEGATED-AT ?KING ?WHO-AT ?WHERE-AT))
                 (INTENDS-AT ?KNIGHT ?WHO-AT ?WHERE-AT)))

  (:action ORDER-DEAD-BECAUSE-MARRIED-TO-B-1
    :parameters (?KING - KING ?KNIGHT - KNIGHT ?WHERE - PLACE ?WHO-DEAD -
                 CHARACTER ?WHO-MARRIED-TO-1 - HUMAN ?WHO-ELSE-MARRIED-TO-1 -
                 HUMAN)
    :precondition (AND
                   (INTENDS-MARRIED-TO ?KING ?WHO-MARRIED-TO-1
                    ?WHO-ELSE-MARRIED-TO-1)
                   (FORALL (?C - CHARACTER)
                    (NOT (DELEGATED-DEAD ?C ?WHO-DEAD)))
                   (AT ?KING ?WHERE)
                   (AT ?KNIGHT ?WHERE)
                   (ALIVE ?KING)
                   (ALIVE ?KNIGHT)
                   (LOYAL-TO ?KING ?KNIGHT))
    :effect (AND
             (NOT
              (JUSTIFIED-DEAD-MARRIED-TO ?WHO-DEAD ?KING ?WHO-MARRIED-TO-1
               ?WHO-ELSE-MARRIED-TO-1))
             (JUSTIFIED-AT-MARRIED-TO ?KING ?WHERE ?KING ?WHO-MARRIED-TO-1
              ?WHO-ELSE-MARRIED-TO-1)
             (JUSTIFIED-AT-MARRIED-TO ?KNIGHT ?WHERE ?KING ?WHO-MARRIED-TO-1
              ?WHO-ELSE-MARRIED-TO-1)
             (DELEGATED-DEAD ?KNIGHT ?WHO-DEAD)
             (NOT (DELEGATED-DEAD ?KING ?WHO-DEAD))
             (INTENDS-DEAD ?KNIGHT ?WHO-DEAD)))

  (:action ORDER-DEAD-BECAUSE-LOVES-B-1
    :parameters (?KING - KING ?KNIGHT - KNIGHT ?WHERE - PLACE ?WHO-DEAD -
                 CHARACTER ?WHO-LOVES-1 - HUMAN ?WHO-ELSE-LOVES-1 - HUMAN)
    :precondition (AND (INTENDS-LOVES ?KING ?WHO-LOVES-1 ?WHO-ELSE-LOVES-1)
                       (FORALL (?C - CHARACTER)
                        (NOT (DELEGATED-DEAD ?C ?WHO-DEAD)))
                       (AT ?KING ?WHERE)
                       (AT ?KNIGHT ?WHERE)
                       (ALIVE ?KING)
                       (ALIVE ?KNIGHT)
                       (LOYAL-TO ?KING ?KNIGHT))
    :effect (AND
             (NOT
              (JUSTIFIED-DEAD-LOVES ?WHO-DEAD ?KING ?WHO-LOVES-1
               ?WHO-ELSE-LOVES-1))
             (JUSTIFIED-AT-LOVES ?KING ?WHERE ?KING ?WHO-LOVES-1
              ?WHO-ELSE-LOVES-1)
             (JUSTIFIED-AT-LOVES ?KNIGHT ?WHERE ?KING ?WHO-LOVES-1
              ?WHO-ELSE-LOVES-1)
             (DELEGATED-DEAD ?KNIGHT ?WHO-DEAD)
             (NOT (DELEGATED-DEAD ?KING ?WHO-DEAD))
             (INTENDS-DEAD ?KNIGHT ?WHO-DEAD)))

  (:action ORDER-DEAD-BECAUSE-CONTROLS-B-1
    :parameters (?KING - KING ?KNIGHT - KNIGHT ?WHERE - PLACE ?WHO-DEAD -
                 CHARACTER ?WHO-CONTROLS-1 - CHARACTER ?GEN-CONTROLS-1 - GENIE)
    :precondition (AND (INTENDS-CONTROLS ?KING ?WHO-CONTROLS-1 ?GEN-CONTROLS-1)
                       (FORALL (?C - CHARACTER)
                        (NOT (DELEGATED-DEAD ?C ?WHO-DEAD)))
                       (AT ?KING ?WHERE)
                       (AT ?KNIGHT ?WHERE)
                       (ALIVE ?KING)
                       (ALIVE ?KNIGHT)
                       (LOYAL-TO ?KING ?KNIGHT))
    :effect (AND
             (NOT
              (JUSTIFIED-DEAD-CONTROLS ?WHO-DEAD ?KING ?WHO-CONTROLS-1
               ?GEN-CONTROLS-1))
             (JUSTIFIED-AT-CONTROLS ?KING ?WHERE ?KING ?WHO-CONTROLS-1
              ?GEN-CONTROLS-1)
             (JUSTIFIED-AT-CONTROLS ?KNIGHT ?WHERE ?KING ?WHO-CONTROLS-1
              ?GEN-CONTROLS-1)
             (DELEGATED-DEAD ?KNIGHT ?WHO-DEAD)
             (NOT (DELEGATED-DEAD ?KING ?WHO-DEAD))
             (INTENDS-DEAD ?KNIGHT ?WHO-DEAD)))

  (:action ORDER-DEAD-BECAUSE-HAS-B-1
    :parameters (?KING - KING ?KNIGHT - KNIGHT ?WHERE - PLACE ?WHO-DEAD -
                 CHARACTER ?WHO-HAS-1 - CHARACTER ?WHAT-HAS-1 - THING)
    :precondition (AND (INTENDS-HAS ?KING ?WHO-HAS-1 ?WHAT-HAS-1)
                       (FORALL (?C - CHARACTER)
                        (NOT (DELEGATED-DEAD ?C ?WHO-DEAD)))
                       (AT ?KING ?WHERE)
                       (AT ?KNIGHT ?WHERE)
                       (ALIVE ?KING)
                       (ALIVE ?KNIGHT)
                       (LOYAL-TO ?KING ?KNIGHT))
    :effect (AND
             (NOT (JUSTIFIED-DEAD-HAS ?WHO-DEAD ?KING ?WHO-HAS-1 ?WHAT-HAS-1))
             (JUSTIFIED-AT-HAS ?KING ?WHERE ?KING ?WHO-HAS-1 ?WHAT-HAS-1)
             (JUSTIFIED-AT-HAS ?KNIGHT ?WHERE ?KING ?WHO-HAS-1 ?WHAT-HAS-1)
             (DELEGATED-DEAD ?KNIGHT ?WHO-DEAD)
             (NOT (DELEGATED-DEAD ?KING ?WHO-DEAD))
             (INTENDS-DEAD ?KNIGHT ?WHO-DEAD)))

  (:action ORDER-HAS-BECAUSE-MARRIED-TO-B-1
    :parameters (?KING - KING ?KNIGHT - KNIGHT ?WHERE - PLACE ?WHO-HAS -
                 CHARACTER ?WHAT-HAS - THING ?WHO-MARRIED-TO-1 - HUMAN
                 ?WHO-ELSE-MARRIED-TO-1 - HUMAN)
    :precondition (AND
                   (INTENDS-MARRIED-TO ?KING ?WHO-MARRIED-TO-1
                    ?WHO-ELSE-MARRIED-TO-1)
                   (FORALL (?C - CHARACTER)
                    (NOT (DELEGATED-HAS ?C ?WHO-HAS ?WHAT-HAS)))
                   (AT ?KING ?WHERE)
                   (AT ?KNIGHT ?WHERE)
                   (ALIVE ?KING)
                   (ALIVE ?KNIGHT)
                   (LOYAL-TO ?KING ?KNIGHT))
    :effect (AND
             (NOT
              (JUSTIFIED-HAS-MARRIED-TO ?WHO-HAS ?WHAT-HAS ?KING
               ?WHO-MARRIED-TO-1 ?WHO-ELSE-MARRIED-TO-1))
             (JUSTIFIED-AT-MARRIED-TO ?KING ?WHERE ?KING ?WHO-MARRIED-TO-1
              ?WHO-ELSE-MARRIED-TO-1)
             (JUSTIFIED-AT-MARRIED-TO ?KNIGHT ?WHERE ?KING ?WHO-MARRIED-TO-1
              ?WHO-ELSE-MARRIED-TO-1)
             (DELEGATED-HAS ?KNIGHT ?WHO-HAS ?WHAT-HAS)
             (NOT (DELEGATED-HAS ?KING ?WHO-HAS ?WHAT-HAS))
             (INTENDS-HAS ?KNIGHT ?WHO-HAS ?WHAT-HAS)))

  (:action ORDER-HAS-BECAUSE-LOVES-B-1
    :parameters (?KING - KING ?KNIGHT - KNIGHT ?WHERE - PLACE ?WHO-HAS -
                 CHARACTER ?WHAT-HAS - THING ?WHO-LOVES-1 - HUMAN
                 ?WHO-ELSE-LOVES-1 - HUMAN)
    :precondition (AND (INTENDS-LOVES ?KING ?WHO-LOVES-1 ?WHO-ELSE-LOVES-1)
                       (FORALL (?C - CHARACTER)
                        (NOT (DELEGATED-HAS ?C ?WHO-HAS ?WHAT-HAS)))
                       (AT ?KING ?WHERE)
                       (AT ?KNIGHT ?WHERE)
                       (ALIVE ?KING)
                       (ALIVE ?KNIGHT)
                       (LOYAL-TO ?KING ?KNIGHT))
    :effect (AND
             (NOT
              (JUSTIFIED-HAS-LOVES ?WHO-HAS ?WHAT-HAS ?KING ?WHO-LOVES-1
               ?WHO-ELSE-LOVES-1))
             (JUSTIFIED-AT-LOVES ?KING ?WHERE ?KING ?WHO-LOVES-1
              ?WHO-ELSE-LOVES-1)
             (JUSTIFIED-AT-LOVES ?KNIGHT ?WHERE ?KING ?WHO-LOVES-1
              ?WHO-ELSE-LOVES-1)
             (DELEGATED-HAS ?KNIGHT ?WHO-HAS ?WHAT-HAS)
             (NOT (DELEGATED-HAS ?KING ?WHO-HAS ?WHAT-HAS))
             (INTENDS-HAS ?KNIGHT ?WHO-HAS ?WHAT-HAS)))

  (:action ORDER-HAS-BECAUSE-CONTROLS-B-1
    :parameters (?KING - KING ?KNIGHT - KNIGHT ?WHERE - PLACE ?WHO-HAS -
                 CHARACTER ?WHAT-HAS - THING ?WHO-CONTROLS-1 - CHARACTER
                 ?GEN-CONTROLS-1 - GENIE)
    :precondition (AND (INTENDS-CONTROLS ?KING ?WHO-CONTROLS-1 ?GEN-CONTROLS-1)
                       (FORALL (?C - CHARACTER)
                        (NOT (DELEGATED-HAS ?C ?WHO-HAS ?WHAT-HAS)))
                       (AT ?KING ?WHERE)
                       (AT ?KNIGHT ?WHERE)
                       (ALIVE ?KING)
                       (ALIVE ?KNIGHT)
                       (LOYAL-TO ?KING ?KNIGHT))
    :effect (AND
             (NOT
              (JUSTIFIED-HAS-CONTROLS ?WHO-HAS ?WHAT-HAS ?KING ?WHO-CONTROLS-1
               ?GEN-CONTROLS-1))
             (JUSTIFIED-AT-CONTROLS ?KING ?WHERE ?KING ?WHO-CONTROLS-1
              ?GEN-CONTROLS-1)
             (JUSTIFIED-AT-CONTROLS ?KNIGHT ?WHERE ?KING ?WHO-CONTROLS-1
              ?GEN-CONTROLS-1)
             (DELEGATED-HAS ?KNIGHT ?WHO-HAS ?WHAT-HAS)
             (NOT (DELEGATED-HAS ?KING ?WHO-HAS ?WHAT-HAS))
             (INTENDS-HAS ?KNIGHT ?WHO-HAS ?WHAT-HAS)))

  (:action ORDER-HAS-BECAUSE-HAS-B-1
    :parameters (?KING - KING ?KNIGHT - KNIGHT ?WHERE - PLACE ?WHO-HAS -
                 CHARACTER ?WHAT-HAS - THING ?WHO-HAS-1 - CHARACTER ?WHAT-HAS-1
                 - THING)
    :precondition (AND (INTENDS-HAS ?KING ?WHO-HAS-1 ?WHAT-HAS-1)
                       (FORALL (?C - CHARACTER)
                        (NOT (DELEGATED-HAS ?C ?WHO-HAS ?WHAT-HAS)))
                       (AT ?KING ?WHERE)
                       (AT ?KNIGHT ?WHERE)
                       (ALIVE ?KING)
                       (ALIVE ?KNIGHT)
                       (LOYAL-TO ?KING ?KNIGHT))
    :effect (AND
             (NOT
              (JUSTIFIED-HAS-HAS ?WHO-HAS ?WHAT-HAS ?KING ?WHO-HAS-1
               ?WHAT-HAS-1))
             (JUSTIFIED-AT-HAS ?KING ?WHERE ?KING ?WHO-HAS-1 ?WHAT-HAS-1)
             (JUSTIFIED-AT-HAS ?KNIGHT ?WHERE ?KING ?WHO-HAS-1 ?WHAT-HAS-1)
             (DELEGATED-HAS ?KNIGHT ?WHO-HAS ?WHAT-HAS)
             (NOT (DELEGATED-HAS ?KING ?WHO-HAS ?WHAT-HAS))
             (INTENDS-HAS ?KNIGHT ?WHO-HAS ?WHAT-HAS)))

  (:action ORDER-LOVES-BECAUSE-MARRIED-TO-B-1
    :parameters (?KING - KING ?KNIGHT - KNIGHT ?WHERE - PLACE ?WHO-LOVES -
                 HUMAN ?WHO-ELSE-LOVES - HUMAN ?WHO-MARRIED-TO-1 - HUMAN
                 ?WHO-ELSE-MARRIED-TO-1 - HUMAN)
    :precondition (AND
                   (INTENDS-MARRIED-TO ?KING ?WHO-MARRIED-TO-1
                    ?WHO-ELSE-MARRIED-TO-1)
                   (FORALL (?C - CHARACTER)
                    (NOT (DELEGATED-LOVES ?C ?WHO-LOVES ?WHO-ELSE-LOVES)))
                   (AT ?KING ?WHERE)
                   (AT ?KNIGHT ?WHERE)
                   (ALIVE ?KING)
                   (ALIVE ?KNIGHT)
                   (LOYAL-TO ?KING ?KNIGHT))
    :effect (AND
             (NOT
              (JUSTIFIED-LOVES-MARRIED-TO ?WHO-LOVES ?WHO-ELSE-LOVES ?KING
               ?WHO-MARRIED-TO-1 ?WHO-ELSE-MARRIED-TO-1))
             (JUSTIFIED-AT-MARRIED-TO ?KING ?WHERE ?KING ?WHO-MARRIED-TO-1
              ?WHO-ELSE-MARRIED-TO-1)
             (JUSTIFIED-AT-MARRIED-TO ?KNIGHT ?WHERE ?KING ?WHO-MARRIED-TO-1
              ?WHO-ELSE-MARRIED-TO-1)
             (DELEGATED-LOVES ?KNIGHT ?WHO-LOVES ?WHO-ELSE-LOVES)
             (NOT (DELEGATED-LOVES ?KING ?WHO-LOVES ?WHO-ELSE-LOVES))
             (INTENDS-LOVES ?KNIGHT ?WHO-LOVES ?WHO-ELSE-LOVES)))

  (:action COMMAND-AT-BECAUSE-MARRIED-TO-B-1
    :parameters (?WHO - CHARACTER ?GEN - GENIE ?LAMP - MAGIC-LAMP ?WHO-AT -
                 CHARACTER ?WHERE-AT - PLACE ?WHO-MARRIED-TO-1 - HUMAN
                 ?WHO-ELSE-MARRIED-TO-1 - HUMAN)
    :precondition (AND
                   (INTENDS-MARRIED-TO ?WHO ?WHO-MARRIED-TO-1
                    ?WHO-ELSE-MARRIED-TO-1)
                   (FORALL (?C - CHARACTER)
                    (NOT (DELEGATED-AT ?C ?WHO-AT ?WHERE-AT)))
                   (ALIVE ?WHO)
                   (ALIVE ?GEN)
                   (HAS ?WHO ?LAMP)
                   (CONTROLS ?WHO ?GEN)
                   (NOT (= ?WHO ?GEN)))
    :effect (AND
             (NOT
              (JUSTIFIED-AT-MARRIED-TO ?WHO-AT ?WHERE-AT ?WHO ?WHO-MARRIED-TO-1
               ?WHO-ELSE-MARRIED-TO-1))
             (JUSTIFIED-HAS-MARRIED-TO ?WHO ?LAMP ?WHO ?WHO-MARRIED-TO-1
              ?WHO-ELSE-MARRIED-TO-1)
             (JUSTIFIED-CONTROLS-MARRIED-TO ?WHO ?GEN ?WHO ?WHO-MARRIED-TO-1
              ?WHO-ELSE-MARRIED-TO-1)
             (DELEGATED-AT ?GEN ?WHO-AT ?WHERE-AT)
             (NOT (DELEGATED-AT ?WHO ?WHO-AT ?WHERE-AT))
             (INTENDS-AT ?GEN ?WHO-AT ?WHERE-AT)))

  (:action COMMAND-AT-BECAUSE-LOVES-B-1
    :parameters (?WHO - CHARACTER ?GEN - GENIE ?LAMP - MAGIC-LAMP ?WHO-AT -
                 CHARACTER ?WHERE-AT - PLACE ?WHO-LOVES-1 - HUMAN
                 ?WHO-ELSE-LOVES-1 - HUMAN)
    :precondition (AND (INTENDS-LOVES ?WHO ?WHO-LOVES-1 ?WHO-ELSE-LOVES-1)
                       (FORALL (?C - CHARACTER)
                        (NOT (DELEGATED-AT ?C ?WHO-AT ?WHERE-AT)))
                       (ALIVE ?WHO)
                       (ALIVE ?GEN)
                       (HAS ?WHO ?LAMP)
                       (CONTROLS ?WHO ?GEN)
                       (NOT (= ?WHO ?GEN)))
    :effect (AND
             (NOT
              (JUSTIFIED-AT-LOVES ?WHO-AT ?WHERE-AT ?WHO ?WHO-LOVES-1
               ?WHO-ELSE-LOVES-1))
             (JUSTIFIED-HAS-LOVES ?WHO ?LAMP ?WHO ?WHO-LOVES-1
              ?WHO-ELSE-LOVES-1)
             (JUSTIFIED-CONTROLS-LOVES ?WHO ?GEN ?WHO ?WHO-LOVES-1
              ?WHO-ELSE-LOVES-1)
             (DELEGATED-AT ?GEN ?WHO-AT ?WHERE-AT)
             (NOT (DELEGATED-AT ?WHO ?WHO-AT ?WHERE-AT))
             (INTENDS-AT ?GEN ?WHO-AT ?WHERE-AT)))

  (:action COMMAND-AT-BECAUSE-CONTROLS-B-1
    :parameters (?WHO - CHARACTER ?GEN - GENIE ?LAMP - MAGIC-LAMP ?WHO-AT -
                 CHARACTER ?WHERE-AT - PLACE ?WHO-CONTROLS-1 - CHARACTER
                 ?GEN-CONTROLS-1 - GENIE)
    :precondition (AND (INTENDS-CONTROLS ?WHO ?WHO-CONTROLS-1 ?GEN-CONTROLS-1)
                       (FORALL (?C - CHARACTER)
                        (NOT (DELEGATED-AT ?C ?WHO-AT ?WHERE-AT)))
                       (ALIVE ?WHO)
                       (ALIVE ?GEN)
                       (HAS ?WHO ?LAMP)
                       (CONTROLS ?WHO ?GEN)
                       (NOT (= ?WHO ?GEN)))
    :effect (AND
             (NOT
              (JUSTIFIED-AT-CONTROLS ?WHO-AT ?WHERE-AT ?WHO ?WHO-CONTROLS-1
               ?GEN-CONTROLS-1))
             (JUSTIFIED-HAS-CONTROLS ?WHO ?LAMP ?WHO ?WHO-CONTROLS-1
              ?GEN-CONTROLS-1)
             (JUSTIFIED-CONTROLS-CONTROLS ?WHO ?GEN ?WHO ?WHO-CONTROLS-1
              ?GEN-CONTROLS-1)
             (DELEGATED-AT ?GEN ?WHO-AT ?WHERE-AT)
             (NOT (DELEGATED-AT ?WHO ?WHO-AT ?WHERE-AT))
             (INTENDS-AT ?GEN ?WHO-AT ?WHERE-AT)))

  (:action COMMAND-AT-BECAUSE-HAS-B-1
    :parameters (?WHO - CHARACTER ?GEN - GENIE ?LAMP - MAGIC-LAMP ?WHO-AT -
                 CHARACTER ?WHERE-AT - PLACE ?WHO-HAS-1 - CHARACTER ?WHAT-HAS-1
                 - THING)
    :precondition (AND (INTENDS-HAS ?WHO ?WHO-HAS-1 ?WHAT-HAS-1)
                       (FORALL (?C - CHARACTER)
                        (NOT (DELEGATED-AT ?C ?WHO-AT ?WHERE-AT)))
                       (ALIVE ?WHO)
                       (ALIVE ?GEN)
                       (HAS ?WHO ?LAMP)
                       (CONTROLS ?WHO ?GEN)
                       (NOT (= ?WHO ?GEN)))
    :effect (AND
             (NOT
              (JUSTIFIED-AT-HAS ?WHO-AT ?WHERE-AT ?WHO ?WHO-HAS-1 ?WHAT-HAS-1))
             (JUSTIFIED-HAS-HAS ?WHO ?LAMP ?WHO ?WHO-HAS-1 ?WHAT-HAS-1)
             (JUSTIFIED-CONTROLS-HAS ?WHO ?GEN ?WHO ?WHO-HAS-1 ?WHAT-HAS-1)
             (DELEGATED-AT ?GEN ?WHO-AT ?WHERE-AT)
             (NOT (DELEGATED-AT ?WHO ?WHO-AT ?WHERE-AT))
             (INTENDS-AT ?GEN ?WHO-AT ?WHERE-AT)))

  (:action COMMAND-AT-BECAUSE-DEAD-B-1
    :parameters (?WHO - CHARACTER ?GEN - GENIE ?LAMP - MAGIC-LAMP ?WHO-AT -
                 CHARACTER ?WHERE-AT - PLACE ?WHO-DEAD-1 - CHARACTER)
    :precondition (AND (INTENDS-DEAD ?WHO ?WHO-DEAD-1)
                       (FORALL (?C - CHARACTER)
                        (NOT (DELEGATED-AT ?C ?WHO-AT ?WHERE-AT)))
                       (ALIVE ?WHO)
                       (ALIVE ?GEN)
                       (HAS ?WHO ?LAMP)
                       (CONTROLS ?WHO ?GEN)
                       (NOT (= ?WHO ?GEN)))
    :effect (AND (NOT (JUSTIFIED-AT-DEAD ?WHO-AT ?WHERE-AT ?WHO ?WHO-DEAD-1))
                 (JUSTIFIED-HAS-DEAD ?WHO ?LAMP ?WHO ?WHO-DEAD-1)
                 (JUSTIFIED-CONTROLS-DEAD ?WHO ?GEN ?WHO ?WHO-DEAD-1)
                 (DELEGATED-AT ?GEN ?WHO-AT ?WHERE-AT)
                 (NOT (DELEGATED-AT ?WHO ?WHO-AT ?WHERE-AT))
                 (INTENDS-AT ?GEN ?WHO-AT ?WHERE-AT)))

  (:action COMMAND-DEAD-BECAUSE-MARRIED-TO-B-1
    :parameters (?WHO - CHARACTER ?GEN - GENIE ?LAMP - MAGIC-LAMP ?WHO-DEAD -
                 CHARACTER ?WHO-MARRIED-TO-1 - HUMAN ?WHO-ELSE-MARRIED-TO-1 -
                 HUMAN)
    :precondition (AND
                   (INTENDS-MARRIED-TO ?WHO ?WHO-MARRIED-TO-1
                    ?WHO-ELSE-MARRIED-TO-1)
                   (FORALL (?C - CHARACTER)
                    (NOT (DELEGATED-DEAD ?C ?WHO-DEAD)))
                   (ALIVE ?WHO)
                   (ALIVE ?GEN)
                   (HAS ?WHO ?LAMP)
                   (CONTROLS ?WHO ?GEN)
                   (NOT (= ?WHO ?GEN)))
    :effect (AND
             (NOT
              (JUSTIFIED-DEAD-MARRIED-TO ?WHO-DEAD ?WHO ?WHO-MARRIED-TO-1
               ?WHO-ELSE-MARRIED-TO-1))
             (JUSTIFIED-HAS-MARRIED-TO ?WHO ?LAMP ?WHO ?WHO-MARRIED-TO-1
              ?WHO-ELSE-MARRIED-TO-1)
             (JUSTIFIED-CONTROLS-MARRIED-TO ?WHO ?GEN ?WHO ?WHO-MARRIED-TO-1
              ?WHO-ELSE-MARRIED-TO-1)
             (DELEGATED-DEAD ?GEN ?WHO-DEAD)
             (NOT (DELEGATED-DEAD ?WHO ?WHO-DEAD))
             (INTENDS-DEAD ?GEN ?WHO-DEAD)))

  (:action COMMAND-DEAD-BECAUSE-LOVES-B-1
    :parameters (?WHO - CHARACTER ?GEN - GENIE ?LAMP - MAGIC-LAMP ?WHO-DEAD -
                 CHARACTER ?WHO-LOVES-1 - HUMAN ?WHO-ELSE-LOVES-1 - HUMAN)
    :precondition (AND (INTENDS-LOVES ?WHO ?WHO-LOVES-1 ?WHO-ELSE-LOVES-1)
                       (FORALL (?C - CHARACTER)
                        (NOT (DELEGATED-DEAD ?C ?WHO-DEAD)))
                       (ALIVE ?WHO)
                       (ALIVE ?GEN)
                       (HAS ?WHO ?LAMP)
                       (CONTROLS ?WHO ?GEN)
                       (NOT (= ?WHO ?GEN)))
    :effect (AND
             (NOT
              (JUSTIFIED-DEAD-LOVES ?WHO-DEAD ?WHO ?WHO-LOVES-1
               ?WHO-ELSE-LOVES-1))
             (JUSTIFIED-HAS-LOVES ?WHO ?LAMP ?WHO ?WHO-LOVES-1
              ?WHO-ELSE-LOVES-1)
             (JUSTIFIED-CONTROLS-LOVES ?WHO ?GEN ?WHO ?WHO-LOVES-1
              ?WHO-ELSE-LOVES-1)
             (DELEGATED-DEAD ?GEN ?WHO-DEAD)
             (NOT (DELEGATED-DEAD ?WHO ?WHO-DEAD))
             (INTENDS-DEAD ?GEN ?WHO-DEAD)))

  (:action COMMAND-DEAD-BECAUSE-CONTROLS-B-1
    :parameters (?WHO - CHARACTER ?GEN - GENIE ?LAMP - MAGIC-LAMP ?WHO-DEAD -
                 CHARACTER ?WHO-CONTROLS-1 - CHARACTER ?GEN-CONTROLS-1 - GENIE)
    :precondition (AND (INTENDS-CONTROLS ?WHO ?WHO-CONTROLS-1 ?GEN-CONTROLS-1)
                       (FORALL (?C - CHARACTER)
                        (NOT (DELEGATED-DEAD ?C ?WHO-DEAD)))
                       (ALIVE ?WHO)
                       (ALIVE ?GEN)
                       (HAS ?WHO ?LAMP)
                       (CONTROLS ?WHO ?GEN)
                       (NOT (= ?WHO ?GEN)))
    :effect (AND
             (NOT
              (JUSTIFIED-DEAD-CONTROLS ?WHO-DEAD ?WHO ?WHO-CONTROLS-1
               ?GEN-CONTROLS-1))
             (JUSTIFIED-HAS-CONTROLS ?WHO ?LAMP ?WHO ?WHO-CONTROLS-1
              ?GEN-CONTROLS-1)
             (JUSTIFIED-CONTROLS-CONTROLS ?WHO ?GEN ?WHO ?WHO-CONTROLS-1
              ?GEN-CONTROLS-1)
             (DELEGATED-DEAD ?GEN ?WHO-DEAD)
             (NOT (DELEGATED-DEAD ?WHO ?WHO-DEAD))
             (INTENDS-DEAD ?GEN ?WHO-DEAD)))

  (:action COMMAND-DEAD-BECAUSE-HAS-B-1
    :parameters (?WHO - CHARACTER ?GEN - GENIE ?LAMP - MAGIC-LAMP ?WHO-DEAD -
                 CHARACTER ?WHO-HAS-1 - CHARACTER ?WHAT-HAS-1 - THING)
    :precondition (AND (INTENDS-HAS ?WHO ?WHO-HAS-1 ?WHAT-HAS-1)
                       (FORALL (?C - CHARACTER)
                        (NOT (DELEGATED-DEAD ?C ?WHO-DEAD)))
                       (ALIVE ?WHO)
                       (ALIVE ?GEN)
                       (HAS ?WHO ?LAMP)
                       (CONTROLS ?WHO ?GEN)
                       (NOT (= ?WHO ?GEN)))
    :effect (AND
             (NOT (JUSTIFIED-DEAD-HAS ?WHO-DEAD ?WHO ?WHO-HAS-1 ?WHAT-HAS-1))
             (JUSTIFIED-HAS-HAS ?WHO ?LAMP ?WHO ?WHO-HAS-1 ?WHAT-HAS-1)
             (JUSTIFIED-CONTROLS-HAS ?WHO ?GEN ?WHO ?WHO-HAS-1 ?WHAT-HAS-1)
             (DELEGATED-DEAD ?GEN ?WHO-DEAD)
             (NOT (DELEGATED-DEAD ?WHO ?WHO-DEAD))
             (INTENDS-DEAD ?GEN ?WHO-DEAD)))

  (:action COMMAND-HAS-BECAUSE-MARRIED-TO-B-1
    :parameters (?WHO - CHARACTER ?GEN - GENIE ?LAMP - MAGIC-LAMP ?WHO-HAS -
                 CHARACTER ?WHAT-HAS - THING ?WHO-MARRIED-TO-1 - HUMAN
                 ?WHO-ELSE-MARRIED-TO-1 - HUMAN)
    :precondition (AND
                   (INTENDS-MARRIED-TO ?WHO ?WHO-MARRIED-TO-1
                    ?WHO-ELSE-MARRIED-TO-1)
                   (FORALL (?C - CHARACTER)
                    (NOT (DELEGATED-HAS ?C ?WHO-HAS ?WHAT-HAS)))
                   (ALIVE ?WHO)
                   (ALIVE ?GEN)
                   (HAS ?WHO ?LAMP)
                   (CONTROLS ?WHO ?GEN)
                   (NOT (= ?WHO ?GEN)))
    :effect (AND
             (NOT
              (JUSTIFIED-HAS-MARRIED-TO ?WHO-HAS ?WHAT-HAS ?WHO
               ?WHO-MARRIED-TO-1 ?WHO-ELSE-MARRIED-TO-1))
             (JUSTIFIED-HAS-MARRIED-TO ?WHO ?LAMP ?WHO ?WHO-MARRIED-TO-1
              ?WHO-ELSE-MARRIED-TO-1)
             (JUSTIFIED-CONTROLS-MARRIED-TO ?WHO ?GEN ?WHO ?WHO-MARRIED-TO-1
              ?WHO-ELSE-MARRIED-TO-1)
             (DELEGATED-HAS ?GEN ?WHO-HAS ?WHAT-HAS)
             (NOT (DELEGATED-HAS ?WHO ?WHO-HAS ?WHAT-HAS))
             (INTENDS-HAS ?GEN ?WHO-HAS ?WHAT-HAS)))

  (:action COMMAND-HAS-BECAUSE-LOVES-B-1
    :parameters (?WHO - CHARACTER ?GEN - GENIE ?LAMP - MAGIC-LAMP ?WHO-HAS -
                 CHARACTER ?WHAT-HAS - THING ?WHO-LOVES-1 - HUMAN
                 ?WHO-ELSE-LOVES-1 - HUMAN)
    :precondition (AND (INTENDS-LOVES ?WHO ?WHO-LOVES-1 ?WHO-ELSE-LOVES-1)
                       (FORALL (?C - CHARACTER)
                        (NOT (DELEGATED-HAS ?C ?WHO-HAS ?WHAT-HAS)))
                       (ALIVE ?WHO)
                       (ALIVE ?GEN)
                       (HAS ?WHO ?LAMP)
                       (CONTROLS ?WHO ?GEN)
                       (NOT (= ?WHO ?GEN)))
    :effect (AND
             (NOT
              (JUSTIFIED-HAS-LOVES ?WHO-HAS ?WHAT-HAS ?WHO ?WHO-LOVES-1
               ?WHO-ELSE-LOVES-1))
             (JUSTIFIED-HAS-LOVES ?WHO ?LAMP ?WHO ?WHO-LOVES-1
              ?WHO-ELSE-LOVES-1)
             (JUSTIFIED-CONTROLS-LOVES ?WHO ?GEN ?WHO ?WHO-LOVES-1
              ?WHO-ELSE-LOVES-1)
             (DELEGATED-HAS ?GEN ?WHO-HAS ?WHAT-HAS)
             (NOT (DELEGATED-HAS ?WHO ?WHO-HAS ?WHAT-HAS))
             (INTENDS-HAS ?GEN ?WHO-HAS ?WHAT-HAS)))

  (:action COMMAND-HAS-BECAUSE-CONTROLS-B-1
    :parameters (?WHO - CHARACTER ?GEN - GENIE ?LAMP - MAGIC-LAMP ?WHO-HAS -
                 CHARACTER ?WHAT-HAS - THING ?WHO-CONTROLS-1 - CHARACTER
                 ?GEN-CONTROLS-1 - GENIE)
    :precondition (AND (INTENDS-CONTROLS ?WHO ?WHO-CONTROLS-1 ?GEN-CONTROLS-1)
                       (FORALL (?C - CHARACTER)
                        (NOT (DELEGATED-HAS ?C ?WHO-HAS ?WHAT-HAS)))
                       (ALIVE ?WHO)
                       (ALIVE ?GEN)
                       (HAS ?WHO ?LAMP)
                       (CONTROLS ?WHO ?GEN)
                       (NOT (= ?WHO ?GEN)))
    :effect (AND
             (NOT
              (JUSTIFIED-HAS-CONTROLS ?WHO-HAS ?WHAT-HAS ?WHO ?WHO-CONTROLS-1
               ?GEN-CONTROLS-1))
             (JUSTIFIED-HAS-CONTROLS ?WHO ?LAMP ?WHO ?WHO-CONTROLS-1
              ?GEN-CONTROLS-1)
             (JUSTIFIED-CONTROLS-CONTROLS ?WHO ?GEN ?WHO ?WHO-CONTROLS-1
              ?GEN-CONTROLS-1)
             (DELEGATED-HAS ?GEN ?WHO-HAS ?WHAT-HAS)
             (NOT (DELEGATED-HAS ?WHO ?WHO-HAS ?WHAT-HAS))
             (INTENDS-HAS ?GEN ?WHO-HAS ?WHAT-HAS)))

  (:action COMMAND-HAS-BECAUSE-HAS-B-1
    :parameters (?WHO - CHARACTER ?GEN - GENIE ?LAMP - MAGIC-LAMP ?WHO-HAS -
                 CHARACTER ?WHAT-HAS - THING ?WHO-HAS-1 - CHARACTER ?WHAT-HAS-1
                 - THING)
    :precondition (AND (INTENDS-HAS ?WHO ?WHO-HAS-1 ?WHAT-HAS-1)
                       (FORALL (?C - CHARACTER)
                        (NOT (DELEGATED-HAS ?C ?WHO-HAS ?WHAT-HAS)))
                       (ALIVE ?WHO)
                       (ALIVE ?GEN)
                       (HAS ?WHO ?LAMP)
                       (CONTROLS ?WHO ?GEN)
                       (NOT (= ?WHO ?GEN)))
    :effect (AND
             (NOT
              (JUSTIFIED-HAS-HAS ?WHO-HAS ?WHAT-HAS ?WHO ?WHO-HAS-1
               ?WHAT-HAS-1))
             (JUSTIFIED-HAS-HAS ?WHO ?LAMP ?WHO ?WHO-HAS-1 ?WHAT-HAS-1)
             (JUSTIFIED-CONTROLS-HAS ?WHO ?GEN ?WHO ?WHO-HAS-1 ?WHAT-HAS-1)
             (DELEGATED-HAS ?GEN ?WHO-HAS ?WHAT-HAS)
             (NOT (DELEGATED-HAS ?WHO ?WHO-HAS ?WHAT-HAS))
             (INTENDS-HAS ?GEN ?WHO-HAS ?WHAT-HAS)))

  (:action COMMAND-LOVES-BECAUSE-MARRIED-TO-B-1
    :parameters (?WHO - CHARACTER ?GEN - GENIE ?LAMP - MAGIC-LAMP ?WHO-LOVES -
                 HUMAN ?WHO-ELSE-LOVES - HUMAN ?WHO-MARRIED-TO-1 - HUMAN
                 ?WHO-ELSE-MARRIED-TO-1 - HUMAN)
    :precondition (AND
                   (INTENDS-MARRIED-TO ?WHO ?WHO-MARRIED-TO-1
                    ?WHO-ELSE-MARRIED-TO-1)
                   (FORALL (?C - CHARACTER)
                    (NOT (DELEGATED-LOVES ?C ?WHO-LOVES ?WHO-ELSE-LOVES)))
                   (ALIVE ?WHO)
                   (ALIVE ?GEN)
                   (HAS ?WHO ?LAMP)
                   (CONTROLS ?WHO ?GEN)
                   (NOT (= ?WHO ?GEN)))
    :effect (AND
             (NOT
              (JUSTIFIED-LOVES-MARRIED-TO ?WHO-LOVES ?WHO-ELSE-LOVES ?WHO
               ?WHO-MARRIED-TO-1 ?WHO-ELSE-MARRIED-TO-1))
             (JUSTIFIED-HAS-MARRIED-TO ?WHO ?LAMP ?WHO ?WHO-MARRIED-TO-1
              ?WHO-ELSE-MARRIED-TO-1)
             (JUSTIFIED-CONTROLS-MARRIED-TO ?WHO ?GEN ?WHO ?WHO-MARRIED-TO-1
              ?WHO-ELSE-MARRIED-TO-1)
             (DELEGATED-LOVES ?GEN ?WHO-LOVES ?WHO-ELSE-LOVES)
             (NOT (DELEGATED-LOVES ?WHO ?WHO-LOVES ?WHO-ELSE-LOVES))
             (INTENDS-LOVES ?GEN ?WHO-LOVES ?WHO-ELSE-LOVES)))

  (:action FALL-IN-LOVE
    :parameters (?WHO - HUMAN ?WITH-WHO - HUMAN ?WHERE - PLACE)
    :precondition (AND (AT ?WHO ?WHERE)
                       (AT ?WITH-WHO ?WHERE)
                       (ALIVE ?WHO)
                       (SINGLE ?WHO)
                       (ALIVE ?WITH-WHO)
                       (BEAUTIFUL ?WITH-WHO))
    :effect (AND (LOVES ?WHO ?WITH-WHO)
                 (INTENDS-MARRIED-TO ?WHO ?WHO ?WITH-WHO)))

  (:action FRIGHTEN
    :parameters (?FRIGHTER - MONSTER ?FRIGHTEE - CHARACTER ?WHERE - PLACE)
    :precondition (AND (AT ?FRIGHTER ?WHERE)
                       (AT ?FRIGHTEE ?WHERE)
                       (ALIVE ?FRIGHTER)
                       (SCARY ?FRIGHTER)
                       (ALIVE ?FRIGHTEE)
                       (NOT (= ?FRIGHTER ?FRIGHTEE)))
    :effect (AND (INTENDS-DEAD ?FRIGHTEE ?FRIGHTER)))

  )
